subroutine write_trajectory(snap, trj_fn, natom)
    implicit none

    integer, intent(in) :: natom
    real(8), intent(in) :: snap(natom, 3)
    character(*), intent(in) :: trj_fn

    integer :: iatm, ixyz
    integer, parameter :: iunit = 11

    ! coorditate trajectory
    open(unit=iunit, file=trj_fn, position='append', form='formatted')
    write(iunit,'(10F8.3)') ((snap(iatm,ixyz),ixyz=1,3), iatm=1,natom)
    close(iunit)

end subroutine

subroutine calrdf(rdfs, crd, num_rs, rmax, dr, per_area, natom)
    implicit none
    integer, intent(in) :: num_rs, natom
    real(8), intent(in) :: crd(natom, 3), rmax, dr
    logical, intent(in) :: per_area
    real(8), intent(out):: rdfs(natom, num_rs)

    integer :: iatm, jatm, ir
    real(8) :: r_ij(3), l_ij, r

    ! initialization
    rdfs = 0.0d0

    ! from here !
    do iatm=1, natom
        do jatm=1, natom
            if (iatm == jatm) cycle
            r_ij = crd(iatm,:) - crd(jatm,:)
            l_ij = sqrt(dot_product(r_ij, r_ij))
            if (l_ij >= rmax) cycle

            ! get r index
            ir = nint(l_ij/dr)

            ! increment for rdf on iatm
            rdfs(iatm, ir) = rdfs(iatm, ir) + 1.0

        enddo
    enddo

    if (per_area) then
        do ir=1, num_rs
            r = dr * ir
            rdfs(:, ir) = rdfs(:, ir) / (r*r)
        enddo
    endif

end subroutine

module distance

    implicit none
    integer, allocatable :: res_beg_end_pairs(:, :) ! (nres, 2)
    real(8) :: cutoff2
    integer :: method ! 1: cog, 2: nearest, 3: farthest

    ! common variables
    integer :: iatm, jatm
    real(8) :: r_ij(3), l2

contains

    subroutine cal_dist2s(dist2s, crd, nres, natom)
        
        implicit none

        integer, intent(in) :: natom, nres
        real(8), intent(in) :: crd(natom, 3)
        real(8), intent(out):: dist2s(nres, nres)

        integer :: ires, jres, ibeg, iend, jbeg, jend
        
        dist2s = 0.0d0

        do ires=1, nres-1
            ibeg = res_beg_end_pairs(ires, 1)
            iend = res_beg_end_pairs(ires, 2)

            do jres=ires+1, nres
                jbeg = res_beg_end_pairs(jres, 1)
                jend = res_beg_end_pairs(jres, 2)

                if (method == 1) then
                    dist2s(ires,jres) = & 
                        & cog_dist2(crd(ibeg:iend,:), crd(jbeg:jend,:))

                else if (method == 2) then
                    dist2s(ires,jres) = & 
                        & nearest_dist2(crd(ibeg:iend,:), crd(jbeg:jend,:))

                else if (method == 3) then
                    dist2s(ires,jres) = & 
                        & farthest_dist2(crd(ibeg:iend,:), crd(jbeg:jend,:))
                end if

            end do

        end do

    end subroutine

    real(8) function cog_dist2(crd_i, crd_j)

        implicit none
        real(8), intent(in) :: crd_i(:,:), crd_j(:,:)

        r_ij(:) = sum(crd_i,1)/size(crd_i,1) - sum(crd_j,1)/size(crd_j,1)
        l2 = dot_product(r_ij, r_ij)
        cog_dist2 = l2

    end function

    real(8) function nearest_dist2(crd_i, crd_j)

        implicit none
        real(8), intent(in) :: crd_i(:,:), crd_j(:,:)

        nearest_dist2 = cutoff2

        do iatm=1, size(crd_i, 1)
            do jatm=1, size(crd_j, 1)

                r_ij(:) = crd_i(iatm,:) - crd_j(jatm,:)
                l2 = dot_product(r_ij, r_ij)
                if (l2 <= nearest_dist2) then
                    nearest_dist2 = l2
                end if

            end do
        end do

    end function

    real(8) function farthest_dist2(crd_i, crd_j)

        implicit none
        real(8), intent(in) :: crd_i(:,:), crd_j(:,:)

        farthest_dist2 = cutoff2

        do iatm=1, size(crd_i, 1)
            do jatm=1, size(crd_j, 1)

                r_ij(:) = crd_i(iatm,:) - crd_j(jatm,:)
                l2 = dot_product(r_ij, r_ij)
                if (l2 >= farthest_dist2) then
                    farthest_dist2 = l2
                end if

            end do
        end do

    end function 

end module

subroutine cal_acf(acf, xss, nacf, first, last, interval, shift, &
                 & norm, nsample, nframe, ncom)

   implicit none
   integer, intent(in) :: nacf, first, last, interval
   integer, intent(in) :: shift, nframe, ncom, nsample
   real(8), intent(in) :: xss(nframe, ncom)
   logical, optional, intent(in) :: norm
   real(8), intent(out):: acf(nacf, ncom)

   real(8) :: x2_sum_inv(ncom), acf_tmp(nacf, ncom)
   integer :: iacf, ifrm, ifrm_beg, nfrm_beg, icom, nsam
   logical :: use_norm

   ! determine the default value of use_norm
   if ( present(norm) ) then
      use_norm = norm
   else
      use_norm = .false.
   end if

   ! determine the number of samples
   if ( nsample <= 0 ) then
      nfrm_beg = nframe - (last-first)
   else if ( nsample >= nframe - (last-first) ) then
      nfrm_beg = nframe - (last-first)
   else
      nfrm_beg = first + shift*(nsample-1)
   end if

   ! << Calculate auto-correlation function >>
   do ifrm_beg=first, nfrm_beg, shift

      ! x**2 for norm
      if (use_norm) then
         x2_sum_inv(:) = 1.0d0/(xss(ifrm_beg,:)*xss(ifrm_beg,:))
      else
         x2_sum_inv(:) = 1.0d0
      end if

      ! calculate acf
      acf_tmp(:,:) = 0.0d0
      do iacf=1, nacf
         ifrm = ifrm_beg + (iacf-1)*interval
         acf_tmp(iacf,:) = xss(ifrm_beg,:) * xss(ifrm,:)
      end do

      ! sum up acf by the number of samples
      do icom=1, ncom
         acf(:,icom) = acf(:,icom) + acf_tmp(:,icom)*x2_sum_inv(icom)
      end do

      ! integral acf
      ! print*, '#lib ', sum(acf_tmp(:,1))

   end do ! samples of one file data

   nsam = (nfrm_beg-first)/shift + 1
   ! print*, first, nfrm_beg, nsam
   acf(:,:) = acf(:,:) / real(nsam)

end subroutine

subroutine initialize__(filename, formlabel, fileno)
    implicit none
    character(*), intent(in) :: filename
    character(*), intent(in) :: formlabel
    integer, intent(out) :: fileno
    integer :: ierr, ifile=10
    logical :: op

    ! get unused file number
    do
        inquire(ifile, opened=op)
        if (.not. op) exit
        ifile = ifile + 1
    end do
    fileno = ifile

    open(fileno, file=filename, status='old', form=formlabel, iostat=ierr)

    ! check
    if (ierr/= 0) then
        write(*,*) 'Could not create a file: ', filename
        stop
    end if
end subroutine

!###############################################################################
module formatted_coordinate
    implicit none
    integer :: fileno

contains
    subroutine initialize(filename)
        implicit none
        character(*), intent(in) :: filename
        call initialize__(filename, 'formatted', fileno)
    end subroutine

    subroutine finalize()
        implicit none
        close(fileno)
    end subroutine

    subroutine parse_next(natom, crd, ierr)
        implicit none
        integer, intent(in) :: natom
        real(8), intent(out):: crd(natom, 3)
        integer, intent(out):: ierr 
        integer :: iatm
        read(fileno, '(10F8.3)', iostat=ierr) &
            & (crd(iatm,1), crd(iatm,2), crd(iatm,3) ,iatm=1, natom)
    end subroutine

    subroutine parse_pbc(box, ierr)
        implicit none
        real(8), intent(out) :: box(3)
        integer, intent(out) :: ierr
        read(fileno, '(10F8.3)', iostat=ierr) box(1), box(2), box(3)
    end subroutine
end module

!###############################################################################
module unformatted_coordinate
    implicit none
    integer :: fileno

contains
    subroutine initialize(filename)
        implicit none
        character(*), intent(in) :: filename
        call initialize__(filename, 'unformatted', fileno)
    end subroutine

    subroutine finalize()
        implicit none
        close(fileno)
    end subroutine

    subroutine parse_next(natom, crd, ierr)
        implicit none
        integer, intent(in) :: natom
        real(8), intent(out):: crd(natom, 3)
        integer, intent(out):: ierr 
        integer :: iatm
        read(fileno, iostat=ierr) &
            & (crd(iatm,1), crd(iatm,2), crd(iatm,3) ,iatm=1, natom)
    end subroutine

    subroutine parse_pbc(box, ierr)
        implicit none
        real(8), intent(out) :: box(3)
        integer, intent(out) :: ierr
        read(fileno, iostat=ierr) box(1), box(2), box(3)
    end subroutine
end module

!###############################################################################
module formatted_velocity
    implicit none
    integer :: fileno

contains
    subroutine initialize(filename)
        implicit none
        character(*), intent(in) :: filename
        call initialize__(filename, 'formatted', fileno)
    end subroutine

    subroutine finalize()
        implicit none
        close(fileno)
    end subroutine

    subroutine parse_next(natom, vel, ierr)
        implicit none
        integer, intent(in) :: natom
        real(8), intent(out):: vel(natom, 3)
        integer, intent(out):: ierr 
        integer :: iatm
        read(fileno, '(10F8.3)', iostat=ierr) &
            & (vel(iatm,1), vel(iatm,2), vel(iatm,3) ,iatm=1, natom)
    end subroutine

    subroutine parse_pbc(box, ierr)
        implicit none
        real(8), intent(out) :: box(3)
        integer, intent(out) :: ierr
        read(fileno, '(10F8.3)', iostat=ierr) box(1), box(2), box(3)
    end subroutine
end module

!###############################################################################
module unformatted_velocity
    implicit none
    integer :: fileno

contains
    subroutine initialize(filename)
        implicit none
        character(*), intent(in) :: filename
        call initialize__(filename, 'unformatted', fileno)
    end subroutine

    subroutine finalize()
        implicit none
        close(fileno)
    end subroutine

    subroutine parse_next(natom, vel, ierr)
        implicit none
        integer, intent(in) :: natom
        real(8), intent(out):: vel(natom, 3)
        integer, intent(out):: ierr 
        integer :: iatm
        read(fileno, iostat=ierr) &
            & (vel(iatm,1), vel(iatm,2), vel(iatm,3) ,iatm=1, natom)
    end subroutine

    subroutine parse_pbc(box, ierr)
        implicit none
        real(8), intent(out) :: box(3)
        integer, intent(out) :: ierr
        read(fileno, iostat=ierr) box(1), box(2), box(3)
    end subroutine
end module

subroutine get_ipair(ipair_ret, iatm, jatm, bonded_pairs, npair)
    implicit none

    integer, intent(in) :: iatm, jatm, npair
    integer, intent(in) :: bonded_pairs(npair, 2)
    integer, intent(out):: ipair_ret
    integer :: ipair, iatm_, jatm_

    ipair_ret = 0
    do ipair=1, npair
        iatm_ = bonded_pairs(ipair, 1)
        jatm_ = bonded_pairs(ipair, 2)

        if (iatm_ == iatm .and. jatm_ == jatm) then
            ipair_ret = ipair
            exit
        else if (iatm_ == jatm .and. jatm_ == iatm) then
            ipair_ret = - ipair
            exit
        end if

    end do

end subroutine

subroutine get_ibnd_to_ipair(ibnd_to_ipair, two_atoms, bonded_pairs, &
                            & nbond, npair)
    implicit none

    integer, intent(in) :: nbond, npair
    integer, intent(in) :: two_atoms(nbond, 2), bonded_pairs(npair, 2)
    integer, intent(out):: ibnd_to_ipair(nbond)

    integer :: ibnd, ipair, iatm, jatm

    do ibnd=1, nbond
        iatm = two_atoms(ibnd, 1)
        jatm = two_atoms(ibnd, 2)

        ! iatm, jatm
        call get_ipair(ipair, iatm, jatm, bonded_pairs, npair)
        ibnd_to_ipair(ibnd) = ipair

    end do

end subroutine

subroutine get_iang_to_ipair(iang_to_ipair, three_atoms, bonded_pairs, &
                            & nangle, npair)
    implicit none

    integer, intent(in) :: nangle, npair
    integer, intent(in) :: three_atoms(nangle, 3), bonded_pairs(npair, 2)
    integer, intent(out):: iang_to_ipair(nangle, 3)

    integer :: iang, ipair, iatm, jatm, katm

    do iang=1, nangle
        iatm = three_atoms(iang, 1)
        jatm = three_atoms(iang, 2)
        katm = three_atoms(iang, 3)

        ! iatm, jatm
        call get_ipair(ipair, iatm, jatm, bonded_pairs, npair)
        iang_to_ipair(iang, 1) = ipair
        ! iatm, katm
        call get_ipair(ipair, iatm, katm, bonded_pairs, npair)
        iang_to_ipair(iang, 2) = ipair
        ! jatm, katm
        call get_ipair(ipair, jatm, katm, bonded_pairs, npair)
        iang_to_ipair(iang, 3) = ipair

    end do

end subroutine

subroutine get_itor_to_ipair(itor_to_ipair, four_atoms, bonded_pairs, &
                            & ntorsion, npair)
    implicit none

    integer, intent(in) :: ntorsion, npair
    integer, intent(in) :: four_atoms(ntorsion, 4), bonded_pairs(npair, 2)
    integer, intent(out):: itor_to_ipair(ntorsion, 6)

    integer :: itor, ipair, iatm, jatm, katm, latm

    do itor=1, ntorsion
        iatm = four_atoms(itor, 1)
        jatm = four_atoms(itor, 2)
        katm = four_atoms(itor, 3)
        latm = four_atoms(itor, 4)

        ! iatm, jatm
        call get_ipair(ipair, iatm, jatm, bonded_pairs, npair)
        itor_to_ipair(itor, 1) = ipair
        ! iatm, katm
        call get_ipair(ipair, iatm, katm, bonded_pairs, npair)
        itor_to_ipair(itor, 2) = ipair
        ! iatm, latm
        call get_ipair(ipair, iatm, latm, bonded_pairs, npair)
        itor_to_ipair(itor, 3) = ipair

        ! jatm, katm
        call get_ipair(ipair, jatm, katm, bonded_pairs, npair)
        itor_to_ipair(itor, 4) = ipair
        ! jatm, latm
        call get_ipair(ipair, jatm, latm, bonded_pairs, npair)
        itor_to_ipair(itor, 5) = ipair
        ! katm, latm
        call get_ipair(ipair, katm, latm, bonded_pairs, npair)
        itor_to_ipair(itor, 6) = ipair

    end do

end subroutine

module utils
    implicit none

    integer :: iatm, jatm, igrp, jgrp, itar, jtar
    real(8) :: f_ij(3), v_ij(3), flux_ij

end module

module bonded

    implicit none
    ! input
    integer :: natom, ntarget, ngroup, ntbf
    integer, allocatable :: target_atoms(:)  ! (ntarget)
    integer, allocatable :: iatm_to_itar(:) ! (natom)
    integer, allocatable :: iatm_to_igrp(:) ! (natom)
    integer, allocatable :: bonded_pairs(:, :)  ! (ntbf, 2)
    logical :: flag_atom, flag_group

    real(8), allocatable :: flux_atm(:, :) ! (ntarget, ntarget)
    real(8), allocatable :: flux_grp(:, :) ! (ngroup, ngroup)

contains

    subroutine initialize(target_atoms_in, iatm_to_igrp_in, & 
            & bonded_pairs_in, &
            & flag_atom_in, flag_group_in, ntarget_in, natom_in, ntbf_in)

        use utils

        implicit none

        integer, intent(in) :: ntarget_in, natom_in, ntbf_in
        integer, intent(in) :: target_atoms_in(ntarget_in)
        integer, intent(in) :: bonded_pairs_in(ntbf_in, 2)
        integer, intent(in) :: iatm_to_igrp_in(natom_in)
        logical, intent(in) :: flag_atom_in, flag_group_in

        natom   = natom_in
        ntarget = ntarget_in
        ntbf    = ntbf_in

        flag_atom  = flag_atom_in
        flag_group = flag_group_in

        if (allocated(target_atoms)) deallocate(target_atoms)
        allocate(target_atoms(ntarget))
        target_atoms = target_atoms_in

        if (allocated(bonded_pairs)) deallocate(bonded_pairs)
        allocate(bonded_pairs(ntbf,2))
        bonded_pairs = bonded_pairs_in

        ! iatm_to_itar(iatm) => itar
        if (allocated(iatm_to_itar)) deallocate(iatm_to_itar)
        allocate(iatm_to_itar(natom))

        iatm_to_itar = 0
        do itar=1, ntarget
            iatm = target_atoms(itar)
            iatm_to_itar(iatm) = itar
        end do

        ! for group
        ngroup = maxval(iatm_to_igrp_in)
        if (allocated(iatm_to_igrp)) deallocate(iatm_to_igrp)
        allocate(iatm_to_igrp(natom))
        iatm_to_igrp = iatm_to_igrp_in

        ! for flux
        ! atomic
        if ( flag_atom ) then
            if (allocated(flux_atm)) deallocate(flux_atm)
            allocate(flux_atm(ntarget, ntarget))
            flux_atm = 0.0d0
        end if 

        ! group
        if ( flag_group ) then
            if (allocated(flux_grp)) deallocate(flux_grp)
            allocate(flux_grp(ngroup, ngroup))
            flux_grp = 0.0d0
        end if

    end subroutine

    subroutine cal_bonded(vel, tbforces, natom_in, ntbf)

        use utils
        implicit none
        integer, intent(in) :: natom_in
        integer, intent(in) :: ntbf
        real(8), intent(in) :: vel(natom_in, 3)
        real(8), intent(in) :: tbforces(ntbf, 3)

        integer :: itbf

        if ( flag_atom  ) flux_atm = 0.0d0
        if ( flag_group ) flux_grp = 0.0d0

        do itbf=1, ntbf
            iatm = bonded_pairs(itbf, 1)
            jatm = bonded_pairs(itbf, 2)

            itar = iatm_to_itar(iatm)
            jtar = iatm_to_itar(jatm)
            if ( (itar==0) .or. (jtar==0) ) cycle

            f_ij(:) = tbforces(itbf, :)
            v_ij(:) = 0.5 * ( vel(iatm,:) + vel(jatm,:) )

            flux_ij = f_ij(1)*v_ij(1) + f_ij(2)*v_ij(2) + f_ij(3)*v_ij(3)

            ! sum up for ith target and jth target
            if ( flag_atom ) then
                flux_atm(itar, jtar) = flux_atm(itar, jtar) + flux_ij
                flux_atm(jtar, itar) = flux_atm(jtar, itar) - flux_ij
            end if

            ! if group calculation is not applied
            if (ngroup == 0) cycle

            ! sum up atomic currents in region of the groups
            if ( flag_group ) then
                igrp = iatm_to_igrp(iatm)
                jgrp = iatm_to_igrp(jatm)

                if ( (igrp == 0) .or. (jgrp==0) ) cycle
                flux_grp(igrp, jgrp) = flux_grp(igrp, jgrp) + flux_ij
                flux_grp(jgrp, igrp) = flux_grp(jgrp, igrp) - flux_ij
            end if

        end do

    end subroutine

end module 


module nonbonded

    implicit none
    ! input
    integer :: natom, ntarget, ngroup
    integer, allocatable :: target_atoms(:)  ! (ntarget)
    integer, allocatable :: iatm_to_itar(:) ! (natom)
    integer, allocatable :: iatm_to_igrp(:) ! (natom)
    logical :: flag_atom, flag_group

    real(8), allocatable :: flux_atm(:, :) ! (ntarget, ntarget)
    real(8), allocatable :: flux_grp(:, :) ! (ngroup, ngroup)

    real(8), allocatable :: vel(:, :) ! (natom, 3)

contains

    subroutine initialize(target_atoms_in, iatm_to_igrp_in, &
                        & flag_atom_in, flag_group_in, &
                        & ntarget_in, natom_in)
        use utils

        implicit none

        integer, intent(in) :: ntarget_in, natom_in
        integer, intent(in) :: target_atoms_in(ntarget_in)
        integer, intent(in) :: iatm_to_igrp_in(natom_in)
        logical, intent(in) :: flag_atom_in, flag_group_in

        natom   = natom_in
        ntarget = ntarget_in

        flag_atom  = flag_atom_in
        flag_group = flag_group_in

        if (allocated(target_atoms)) deallocate(target_atoms)
        allocate(target_atoms(ntarget))
        target_atoms = target_atoms_in

        ! iatm_to_itar(iatm) => itar
        if (allocated(iatm_to_itar)) deallocate(iatm_to_itar)
        allocate(iatm_to_itar(natom))

        iatm_to_itar = 0
        do itar=1, ntarget
            iatm = target_atoms(itar)
            iatm_to_itar(iatm) = itar
        end do

        ! velocity, allcation only
        if (allocated(vel)) deallocate(vel)
        allocate(vel(natom, 3))

        ! for group
        ngroup = maxval(iatm_to_igrp_in)
        if (allocated(iatm_to_igrp)) deallocate(iatm_to_igrp)
        allocate(iatm_to_igrp(natom))
        iatm_to_igrp = iatm_to_igrp_in

        ! for current
        ! atomic
        if ( flag_atom ) then
            if (allocated(flux_atm)) deallocate(flux_atm)
            allocate(flux_atm(ntarget, ntarget))
            flux_atm = 0.0d0
        end if 

        ! group inner
        if ( flag_group ) then
            if (allocated(flux_grp)) deallocate(flux_grp)
            allocate(flux_grp(ngroup, ngroup))
            flux_grp = 0.0d0
        end if

    end subroutine

    subroutine init_cal(vel_in, natom_in)

        implicit none

        integer, intent(in) :: natom_in
        real(8), intent(in) :: vel_in(natom_in, 3)

        ! velocity
        vel = vel_in

        ! initialize flux values
        if ( flag_atom )  flux_atm = 0.0d0
        if ( flag_group ) flux_grp = 0.0d0

    end subroutine

    subroutine cal_nonbonded(tbforces, interact_table, ninteract, ntbf)

        use utils
        implicit none
        integer, intent(in) :: ninteract, ntbf
        integer, intent(in) :: interact_table(ninteract, 3)
        ! (iatm_beg:iatm_end, iatm_beg:natom, :)
        real(8), intent(in) :: tbforces(ntbf, 3)
        integer :: iatm_beg, iatm_end, jatm_beg, jatm_end, jint, itbf

        itbf = 0
        do jint=1, ninteract
            iatm = interact_table(jint, 1)
            itar = iatm_to_itar(iatm)
            if ( itar == 0 ) cycle

            jatm_beg = interact_table(jint, 2)
            jatm_end = interact_table(jint, 3)

            do jatm=jatm_beg, jatm_end
                itbf = itbf + 1 ! increment tbf pointer
                jtar = iatm_to_itar(jatm)
                if ( jtar == 0 ) cycle

                f_ij(:) = tbforces(itbf, :)
                v_ij(:) = 0.5 * ( vel(iatm,:) + vel(jatm,:) )

                flux_ij = f_ij(1)*v_ij(1) + f_ij(2)*v_ij(2) + f_ij(3)*v_ij(3)

                ! sum up for ith target and jth target
                if ( flag_atom ) then
                    flux_atm(itar, jtar) = flux_atm(itar, jtar) + flux_ij
                    flux_atm(jtar, itar) = flux_atm(jtar, itar) - flux_ij
                end if

                ! if group calculation is not applied
                if (ngroup == 0) cycle

                ! sum up atomic currents in region of the groups
                if ( flag_group ) then
                    igrp = iatm_to_igrp(iatm)
                    jgrp = iatm_to_igrp(jatm)

                    if ( (igrp == 0) .or. (jgrp==0) ) cycle
                    flux_grp(igrp, jgrp) = flux_grp(igrp, jgrp) + flux_ij
                    flux_grp(jgrp, igrp) = flux_grp(jgrp, igrp) - flux_ij
                end if

            end do

        end do

    end subroutine

end module

module utils
    implicit none

    integer :: iatm, jatm, igrp, jgrp, itar, jtar
    real(8) :: f_ij(3), r_ij(3), f_ij_r_ij(3, 3)

contains

    function tensor(r1, r2)
        implicit none
        real(8), intent(in) :: r1(3)
        real(8), intent(in) :: r2(3)
        real(8) :: tensor(3, 3)
        integer :: i, j

        do i=1, 3
        do j=1, 3
            tensor(i, j) = r1(i) * r2(j)
        end do
        end do
    end function

end module

module bonded

    implicit none
    ! input
    integer :: natom, ntarget, ngroup, ntbf
    integer, allocatable :: target_atoms(:)  ! (ntarget)
    integer, allocatable :: iatm_to_itars(:) ! (natom)
    integer, allocatable :: iatm_to_igrps(:) ! (natom)
    integer, allocatable :: bonded_pairs(:, :)  ! (ntbf, 2)

    real(8), allocatable :: current(:, :, :)     ! (ntarget, 3, 3)
    real(8), allocatable :: current_inn(:, :, :) ! (ngroup, 3, 3)
    real(8), allocatable :: current_out(:, :, :) ! (ngroup, 3, 3)

contains

    subroutine initialize(target_atoms_in, iatm_to_igrps_in, &
                        & bonded_pairs_in, &
                        & ntarget_in, natom_in, ntbf_in)

        use utils

        implicit none

        integer, intent(in) :: ntarget_in, natom_in, ntbf_in
        integer, intent(in) :: target_atoms_in(ntarget_in)
        integer, intent(in) :: bonded_pairs_in(ntbf_in, 2)
        integer, intent(in) :: iatm_to_igrps_in(natom_in)

        natom   = natom_in
        ntarget = ntarget_in
        ntbf    = ntbf_in

        if (allocated(target_atoms)) deallocate(target_atoms)
        allocate(target_atoms(ntarget))
        target_atoms = target_atoms_in

        if (allocated(bonded_pairs)) deallocate(bonded_pairs)
        allocate(bonded_pairs(ntbf,2))
        bonded_pairs = bonded_pairs_in

        ! iatm_to_itars(iatm) => itar
        if (allocated(iatm_to_itars)) deallocate(iatm_to_itars)
        allocate(iatm_to_itars(natom))

        iatm_to_itars = 0
        do itar=1, ntarget
            iatm = target_atoms(itar)
            iatm_to_itars(iatm) = itar
        end do

        ! for group
        ngroup = maxval(iatm_to_igrps_in)
        if (allocated(iatm_to_igrps)) deallocate(iatm_to_igrps)
        allocate(iatm_to_igrps(natom))
        iatm_to_igrps = iatm_to_igrps_in

        ! for current
        ! atomic
        if (allocated(current)) deallocate(current)
        allocate(current(ntarget, 3, 3))
        current = 0.0d0

        ! group inner
        if (allocated(current_inn)) deallocate(current_inn)
        allocate(current_inn(ngroup, 3, 3))
        current_inn = 0.0d0

        ! group outer
        if (allocated(current_out)) deallocate(current_out)
        allocate(current_out(ngroup, 3, 3))
        current_out = 0.0d0

    end subroutine

    subroutine cal_bonded(crd, tbforces, volumes, gvolumes, &
                & natom_in, ntbf, ntarget_in, ngroup_in)

        use utils
        implicit none
        integer, intent(in) :: natom_in, ntarget_in, ngroup_in
        integer, intent(in) :: ntbf
        real(8), intent(in) :: crd(natom_in, 3)
        real(8), intent(in) :: tbforces(ntbf, 3)
        real(8), intent(in) :: volumes(ntarget_in), gvolumes(ngroup_in)

        integer :: itbf

        current = 0.0d0
        current_inn = 0.0d0
        current_out = 0.0d0

        do itbf=1, ntbf
            iatm = bonded_pairs(itbf, 1)
            jatm = bonded_pairs(itbf, 2)

            itar = iatm_to_itars(iatm)
            jtar = iatm_to_itars(jatm)

            if ( (itar == 0) .and. (jtar == 0) ) cycle

            f_ij(:) = tbforces(itbf,:)
            r_ij(:) = crd(iatm,:) - crd(jatm,:)
            f_ij_r_ij = tensor(f_ij, r_ij)

            ! sum up for iatm
            if ( itar /= 0 ) then
                current(itar, :, :) = current(itar, :, :) & 
                    & + 0.5 * f_ij_r_ij(:, :) / volumes(itar)
            end if

            ! sum up for jatm
            if ( jtar /= 0 ) then
                current(jtar, :, :) = current(jtar, :, :) & 
                    & + 0.5 * f_ij_r_ij(:, :) / volumes(jtar)
            end if

            ! if group calculation is not applied
            if (ngroup == 0) cycle

            ! sum up atomic currents in region of the groups
            igrp = iatm_to_igrps(iatm)
            jgrp = iatm_to_igrps(jatm)

            if ( (igrp == 0) .and. (jgrp == 0) ) cycle

            ! sum up for inside region of the group
            if ( igrp == jgrp ) then
                ! plus the atomic current two times for one group
                current_inn(igrp, :, :) = current_inn(igrp, :, :) & 
                    & + f_ij_r_ij(:,:) / gvolumes(igrp)
                cycle
            end if

            ! contributions from outside of region for group
            ! sum up for ith group
            if ( igrp /= 0 ) then
                current_out(igrp, :, :) = current_out(igrp, :, :)  & 
                    & + 0.5 * f_ij_r_ij(:, :) / gvolumes(igrp)
            end if

            ! sum up for jth group
            if ( jgrp /= 0 ) then
                current_out(jgrp, :, :) = current_out(jgrp, :, :)  & 
                    & + 0.5 * f_ij_r_ij(:, :) / gvolumes(jgrp)
            end if

        end do

    end subroutine

end module 


module nonbonded

    implicit none
    ! input
    integer :: natom, ntarget, ngroup
    integer, allocatable :: target_atoms(:)  ! (ntarget)
    integer, allocatable :: iatm_to_itars(:) ! (natom)
    integer, allocatable :: iatm_to_igrps(:) ! (natom)

    real(8), allocatable :: current(:, :, :)     ! (ntarget, 3, 3)
    real(8), allocatable :: current_inn(:, :, :) ! (ngroup, 3, 3)
    real(8), allocatable :: current_out(:, :, :) ! (ngroup, 3, 3)

    real(8), allocatable :: crd(:, :) ! (natom, 3)
    real(8), allocatable :: volumes(:), gvolumes(:) ! (ntarget), (ngroup)

contains

    subroutine initialize(target_atoms_in, iatm_to_igrps_in, &
                        & ntarget_in, natom_in)
        use utils

        implicit none

        integer, intent(in) :: ntarget_in, natom_in
        integer, intent(in) :: target_atoms_in(ntarget_in)
        integer, intent(in) :: iatm_to_igrps_in(natom_in)

        natom   = natom_in
        ntarget = ntarget_in

        if (allocated(target_atoms)) deallocate(target_atoms)
        allocate(target_atoms(ntarget))
        target_atoms = target_atoms_in

        ! iatm_to_itars(iatm) => itar
        if (allocated(iatm_to_itars)) deallocate(iatm_to_itars)
        allocate(iatm_to_itars(natom))

        iatm_to_itars = 0
        do itar=1, ntarget
            iatm = target_atoms(itar)
            iatm_to_itars(iatm) = itar
        end do

        ! for group
        ngroup = maxval(iatm_to_igrps_in)
        if (allocated(iatm_to_igrps)) deallocate(iatm_to_igrps)
        allocate(iatm_to_igrps(natom))
        iatm_to_igrps = iatm_to_igrps_in

        ! for current
        ! atomic
        if (allocated(current)) deallocate(current)
        allocate(current(ntarget, 3, 3))
        current = 0.0d0

        ! group inner
        if (allocated(current_inn)) deallocate(current_inn)
        allocate(current_inn(ngroup, 3, 3))
        current_inn = 0.0d0

        ! group outer
        if (allocated(current_out)) deallocate(current_out)
        allocate(current_out(ngroup, 3, 3))
        current_out = 0.0d0

    end subroutine

    subroutine init_cal(crd_in, volumes_in, gvolumes_in, &
            & ntarget_in, natom_in, ngroup_in)

        implicit none

        integer, intent(in) :: ntarget_in, natom_in, ngroup_in
        real(8), intent(in) :: crd_in(natom_in, 3)
        real(8), intent(in) :: volumes_in(ntarget_in), gvolumes_in(ngroup_in)

        ! coordinate
        if (allocated(crd)) deallocate(crd)
        allocate(crd(natom, 3))
        crd = crd_in

        ! volumes
        if (allocated(volumes)) deallocate(volumes)
        allocate(volumes(ntarget))
        volumes = volumes_in

        ! group volumes
        if (allocated(gvolumes)) deallocate(gvolumes)
        allocate(gvolumes(ngroup))
        gvolumes = gvolumes_in

        if ( natom_in /= natom ) then
            print*, " The number of atoms is invalid: ", natom_in, natom
            stop
        end if

        if ( ntarget_in /= ntarget ) then
            print*, " The number of targets is invalid: ", ntarget_in, ntarget
            stop
        end if

        if ( ngroup_in /= ngroup ) then
            print*, " The number of groups is invalid: ", ngroup_in, ngroup
            stop
        end if

        ! current
        current = 0.0d0
        current_inn = 0.0d0
        current_out = 0.0d0

    end subroutine

    subroutine cal_nonbonded(tbforces, interact_table, ninteract, ntbf)

        use utils
        implicit none
        integer, intent(in) :: ninteract, ntbf
        integer, intent(in) :: interact_table(ninteract, 3)
        ! (iatm_beg:iatm_end, iatm_beg:natom, :)
        real(8), intent(in) :: tbforces(ntbf, 3)
        integer :: iatm_beg, iatm_end, jatm_beg, jatm_end, jint, itbf

        itbf = 0
        do jint=1, ninteract
            iatm = interact_table(jint, 1)
            itar = iatm_to_itars(iatm)

            jatm_beg = interact_table(jint, 2)
            jatm_end = interact_table(jint, 3)

            do jatm=jatm_beg, jatm_end
                itbf = itbf + 1
                jtar = iatm_to_itars(jatm)
                if ( (itar == 0) .and. (jtar == 0) ) cycle

                f_ij(:) = tbforces(itbf, :)
                r_ij(:) = crd(iatm, :) - crd(jatm, :)
                f_ij_r_ij = tensor(f_ij, r_ij)

                ! sum up for iatm
                if ( itar /= 0 ) then
                    current(itar, :, :) = current(itar, :, :) &
                        & + 0.5 * f_ij_r_ij(:, :) / volumes(itar)
                end if

                ! sum up for jatm
                if ( jtar /= 0 ) then
                    current(jtar, :, :) = current(jtar, :, :) & 
                        & + 0.5 * f_ij_r_ij(:, :) / volumes(jtar)
                end if

                ! if group calculation is not applied
                if (ngroup == 0) cycle

                ! sum up atomic currents in region of the groups
                igrp = iatm_to_igrps(iatm)
                jgrp = iatm_to_igrps(jatm)

                if ( (igrp == 0) .and. (jgrp == 0) ) cycle

                ! sum up for inner region of the group
                if ( igrp == jgrp ) then
                    ! plus the atomic current two times for one group
                    current_inn(igrp, :, :) = current_inn(igrp, :, :) & 
                        & + f_ij_r_ij(:,:) / gvolumes(igrp)
                    cycle
                end if

                ! contributions from outside of region for group
                ! sum up for ith group
                if ( igrp /= 0 ) then
                    current_out(igrp, :, :) = current_out(igrp, :, :)  & 
                        & + 0.5 * f_ij_r_ij(:, :) / gvolumes(igrp)
                end if

                ! sum up for jth group
                if ( jgrp /= 0 ) then
                    current_out(jgrp, :, :) = current_out(jgrp, :, :)  & 
                        & + 0.5 * f_ij_r_ij(:, :) / gvolumes(jgrp)
                end if

            end do

        end do

    end subroutine

end module


module kinetic

    implicit none
    ! input
    integer :: natom, ntarget, ngroup
    integer, allocatable :: target_atoms(:)  ! (ntarget)
    integer, allocatable :: iatm_to_itars(:) ! (natom)
    integer, allocatable :: iatm_to_igrps(:) ! (natom)

    real(8), allocatable :: current(:, :, :)     ! (ntarget, 3, 3)
    real(8), allocatable :: current_inn(:, :, :) ! (ngroup, 3, 3)
    real(8), allocatable :: current_out(:, :, :) ! (ngroup, 3, 3)

contains

    subroutine initialize(target_atoms_in, iatm_to_igrps_in, &
                        & ntarget_in, natom_in)

        use utils

        implicit none

        integer, intent(in) :: ntarget_in, natom_in
        integer, intent(in) :: target_atoms_in(ntarget_in)
        integer, intent(in) :: iatm_to_igrps_in(natom_in)

        natom   = natom_in
        ntarget = ntarget_in

        if (allocated(target_atoms)) deallocate(target_atoms)
        allocate(target_atoms(ntarget))
        target_atoms = target_atoms_in

        ! iatm_to_itars(iatm) => itar
        if (allocated(iatm_to_itars)) deallocate(iatm_to_itars)
        allocate(iatm_to_itars(natom))

        iatm_to_itars = 0
        do itar=1, ntarget
            iatm = target_atoms(itar)
            iatm_to_itars(iatm) = itar
        end do

        ! for group
        ngroup = maxval(iatm_to_igrps_in)
        if (allocated(iatm_to_igrps)) deallocate(iatm_to_igrps)
        allocate(iatm_to_igrps(natom))
        iatm_to_igrps = iatm_to_igrps_in

        ! for current
        ! atomic
        if (allocated(current)) deallocate(current)
        allocate(current(ntarget, 3, 3))
        current = 0.0d0

        ! group inner
        if (allocated(current_inn)) deallocate(current_inn)
        allocate(current_inn(ngroup, 3, 3))
        current_inn = 0.0d0

        ! group outer
        if (allocated(current_out)) deallocate(current_out)
        allocate(current_out(ngroup, 3, 3))
        current_out = 0.0d0

    end subroutine

    subroutine cal_kinetic(vel, masses, volumes, gvolumes, &
                & natom_in, ntarget_in, ngroup_in)

        use utils

        implicit none
        integer, intent(in) :: natom_in, ntarget_in, ngroup_in
        real(8), intent(in) :: vel(natom_in, 3), masses(natom_in)
        real(8), intent(in) :: volumes(ntarget_in), gvolumes(ngroup_in)

        real(8) :: vel2_mass(3, 3)

        ! initialization
        current = 0.0d0
        current_inn = 0.0d0
        current_out = 0.0d0

        do itar=1, ntarget
            iatm = target_atoms(itar)

            vel2_mass(:, :) = tensor( vel(iatm,:), vel(iatm,:)*masses(iatm) )

            current(itar, :, :) = vel2_mass(:, :) / volumes(itar)

            if (ngroup == 0) cycle

            ! sum up atomic currents in region of the groups
            igrp = iatm_to_igrps(iatm)

            ! sum up for ith group
            if ( igrp /= 0 ) then
                current_inn(igrp, :, :) = current_inn(igrp, :, :)  & 
                    & + vel2_mass(:, :) / gvolumes(igrp)
            end if

        end do

    end subroutine

end module 

module limit
    implicit none

    integer, parameter :: maxcan=1000, maxver=500

end module

module voronoi_one

    use limit

    implicit none

    ! input variables
    logical, allocatable :: is_enable_atoms(:) ! (natom)
    real(8), allocatable :: crd(:, :)
    integer :: natom
    real(8) :: cutoff, box

    ! voronoi analysis informations obtained
    integer :: nface, ncan, nedge, nver
    integer :: can_to_iatm(maxcan), edges(maxcan)
    real(8) :: can_crd(maxcan, 3), can_len2(maxcan)
    real(8) :: ver_crd(maxver, 3)
    integer :: ver_to_3cans(maxver,3)

    ! neighbour list
    integer :: nnab, nab_list(maxver)

contains

    subroutine initialize(is_enable_atoms_in, cutoff_in, box_in, natom_in)
        implicit none
        integer, intent(in) :: natom_in   ! the number of atoms
        logical, intent(in) :: is_enable_atoms_in(natom_in)
        real(8), intent(in) :: cutoff_in, box_in

        ! initialize
        natom = natom_in
        cutoff = cutoff_in
        box = box_in

        ! allocate and initialize
        if ( allocated(is_enable_atoms) ) deallocate(is_enable_atoms)
        allocate(is_enable_atoms(natom))
        is_enable_atoms = is_enable_atoms_in

        ! allocate only
        if ( allocated(crd) ) deallocate(crd)
        allocate(crd(natom, 3))

    end subroutine

end module


subroutine set_crd(crd_in, natom_in)

    use voronoi_one

    integer, intent(in) :: natom_in
    real(8), intent(in) :: crd_in(natom_in, 3)

    crd = crd_in

end subroutine


subroutine cal_voronoi_one(volume, iatm)

! *******************************************************************
! ** one of all main loop
! *******************************************************************

    use limit
    use voronoi_one

    implicit none

    ! return variables
    real(8), intent(out):: volume

    ! arguments variables
    integer :: iatm

    integer :: itar, jatm
    real(8) :: r_ij(3), l_ij2, lcut2
    integer :: ican, jcan, kcan, iver

    ! **************************************************

    nnab = 0
    nab_list = 0

    ! select candidates
    call get_candidates( iatm )

    ! sort into ascending order of distance 
    ! TODO: should improve efficiency
    call sort_dist(can_crd, can_len2, can_to_iatm, ncan)

    ! perform voronoi analysis
    call ana_voronoi( volume )

    ! summary
    nnab = 0
    nab_list = 0
    do ican=1, ncan
        if ( edges(ican) == 0 ) cycle

        nnab = nnab + 1
        nab_list(nnab) = can_to_iatm(ican)

    end do

end subroutine

subroutine get_candidates(iatm)

    use limit
    use voronoi_one

    implicit none

    ! argument variables
    integer :: iatm

    ! other variables
    integer :: jatm, ican, jcan
    real(8) :: pos_i(3), r_ij(3), l_ij2, lcut2

    lcut2 = cutoff*cutoff

    pos_i(:) = crd(iatm, :)
    ican = 0
    do jatm=1, natom
        if ( iatm == jatm ) cycle
        if ( .not. is_enable_atoms(jatm) ) cycle

        r_ij(:) = crd(iatm, :) - crd(jatm, :)
        r_ij(:) = r_ij(:) - anint(r_ij(:) / box) * box
        l_ij2 = r_ij(1)**2 + r_ij(2)**2 + r_ij(3)**2

        if (l_ij2 < lcut2) then

            ican = ican + 1

            if (ican > maxcan) then
                print*, ' too many candidates, ', ican
                stop
            endif

            can_crd(ican,:)   = r_ij(:)
            can_len2(ican)    = l_ij2
            can_to_iatm(ican) = jatm

        endif

    enddo

    ! candidates have been selected
    ncan = ican

end subroutine

subroutine ana_voronoi(volume)

! *******************************************************************
! ** routine to perform voronoi analysis                           **
! ** and calculate volume per polyhedron                           **
! **                                                               **
! ** We work initially on double the correct scale,                **
! ** i.e. the faces of the polyhedron go through the points.       **
! *******************************************************************

    use limit
    use voronoi_one

    implicit none

    ! output arguments
    real(8) :: volume

    logical :: ok
    integer :: iver, ican, jcan, kcan, lcan
    real(8) :: ai, bi, ci, di, aj, bj, cj, dj, ak, bk, ck, dk
    real(8) :: ab, bc, ca, da, db, dc, det
    real(8) :: vxijk, vyijk, vzijk
    real(8), parameter :: tol = 1.e-6

    real(8) :: face_volume
    integer :: faces_to_vertices(maxcan, 15)

    ! *******************************************************************

    ! ** If there are less than 4 points given, 
    ! ** We cannot construct a polyhedron

    if ( ncan < 4 ) then
        print*, ' less than 4 points given to voronoi analysis ', ncan
        stop
    endif

    iver = 0

    ! ** We aim to examine each possible vertex defined by the intersection
    ! ** of 3 planes each plane is specified by can_crd, can_len2

    do ican=1, ncan-2 ! 400

        ai = can_crd(ican, 1)
        bi = can_crd(ican, 2)
        ci = can_crd(ican, 3)
        di = -can_len2(ican)

        do jcan=ican+1, ncan-1 ! 300

            aj = can_crd(jcan, 1)
            bj = can_crd(jcan, 2)
            cj = can_crd(jcan, 3)
            dj = -can_len2(jcan)

            ab = ai * bj - aj * bi
            bc = bi * cj - bj * ci
            ca = ci * aj - cj * ai
            da = di * aj - dj * ai
            db = di * bj - dj * bi
            dc = di * cj - dj * ci

            do kcan=jcan+1, ncan ! 200

                ak = can_crd(kcan, 1)
                bk = can_crd(kcan, 2)
                ck = can_crd(kcan, 3)
                dk = -can_len2(kcan)

                det = ak * bc + bk * ca + ck * ab

                if ( abs(det) > tol ) then

                    ! the planes intersect

                    vxijk = ( - dk * bc + bk * dc - ck * db ) / det
                    vyijk = ( - ak * dc - dk * ca + ck * da ) / det
                    vzijk = (   ak * db - bk * da - dk * ab ) / det

                    ! now we take shots at the vertex
                    ! using the remaining planes ...

                    ok = .true.
                    do lcan=1, ncan
                        if ( .not. ok) exit

                        if ( ( lcan /= ican ) .and. &
                           & ( lcan /= jcan ) .and. &
                           & ( lcan /= kcan )       ) then

                             oK = ( ( can_crd(lcan,1) * vxijk &
                                  & + can_crd(lcan,2) * vyijk &
                                  & + can_crd(lcan,3) * vzijk ) & 
                                  & <= can_len2(lcan) )

                        endif

                    enddo

                    ! if the vertex made it add it to the hall of fame
                    ! convert to correct scale

                    if ( ok ) then
                        iver = iver + 1
                        if ( iver > maxver ) stop 'too many vertices'

                        ver_to_3cans(iver, 1) = ican
                        ver_to_3cans(iver, 2) = jcan
                        ver_to_3cans(iver, 3) = kcan
                        ver_crd(iver, 1) = 0.5 * vxijk
                        ver_crd(iver, 2) = 0.5 * vyijk
                        ver_crd(iver, 3) = 0.5 * vzijk

                    endif

                endif

            enddo

        enddo

    enddo

    nver = iver

    if ( nver  < 4 ) then
        print*, ' less than 4 vertices fount in work ', nver
        stop
    endif

    ! ** Identify neighbouring points and
    ! ** gather edges(vertices) index for each faces(polygon or plane). 

    faces_to_vertices = 0
    edges = 0

    do iver = 1, nver

        ican = ver_to_3cans(iver, 1)
        jcan = ver_to_3cans(iver, 2)
        kcan = ver_to_3cans(iver, 3)

        edges(ican) = edges(ican) + 1
        edges(jcan) = edges(jcan) + 1
        edges(kcan) = edges(kcan) + 1

        faces_to_vertices( ican, edges(ican) ) = iver
        faces_to_vertices( jcan, edges(jcan) ) = iver
        faces_to_vertices( kcan, edges(kcan) ) = iver

    enddo

    ! sort vertices in order.
    do ican=1, ncan
        call sort_vertices(faces_to_vertices(ican,:), & 
                & edges(ican), ver_crd, nver)
    enddo

    ! accumulate the volumes for all polygons
    volume = 0.0
    do ican=1, ncan
        call cal_volume(face_volume, & 
             & faces_to_vertices(ican,:), edges(ican), ver_crd, nver)
        volume = volume + face_volume
    enddo

    ! points with nonzero edges are neighbours

    ! check euler relation

    nface = 0
    nedge = 0

    do ican=1, ncan
       if ( edges(ican) > 0 ) nface = nface + 1
       nedge = nedge + edges(ican)
    enddo

    if ( mod(nedge, 2) /= 0 ) then
        print*, 'The number of edges in non-integer ', nedge
        stop
    endif

    if ( ( nver - nedge/2 + nface ) /= 2 ) then
        print*,' **** EULER ERROR: DEGENERACY ? **** '
    endif

end subroutine



subroutine sort_dist(pcrd, plen2, tag, ncan)

!    *******************************************************************
!    ** ROUTINE TO SORT NEIGHBOURS INTO INCREASING ORDER OF DISTANCE  **
!    **                                                               **
!    ** FOR SIMPLICITY WE USE A BUBBLE SORT - OK FOR MAXCAN SMALL.    **
!    *******************************************************************

    use limit

    ! input and output
    integer :: ncan
    real(8), intent(inout) :: pcrd(maxcan, 3)
    real(8), intent(inout) :: plen2(maxcan)
    integer, intent(inout) :: tag(maxcan)

    logical :: change
    integer :: itop, ican, tag_i
    real(8) :: r_i(3), l_i

!*******************************************************************

    change = .true.

    do itop=ncan-1, 1, -1
        if (.not. change) exit

        change = .false.

        do ican=1, itop
            if ( plen2(ican) <= plen2(ican+1) ) cycle

            r_i(:) = pcrd(ican,:)
            l_i = plen2(ican)
            tag_i = tag(ican)

            pcrd(ican,:) = pcrd(ican+1,:)
            plen2(ican) = plen2(ican+1)
            tag(ican) = tag(ican+1)

            pcrd(ican+1,:) = r_i(:)
            plen2(ican+1) = l_i
            tag(ican+1) = tag_i

            change = .true.

        enddo

    enddo
    ! return
end subroutine


subroutine sort_vertices(face_to_vertices, nedge, ver_crd, nver)

! *******************************************************************
! ** Routine to sort vertice in one face into increasing order     **
! ** of distance                                                   **
! *******************************************************************

    use limit

    implicit none

    ! input arguments
    integer :: nedge, nver
    real(8) :: ver_crd(maxver, 3)

    ! input output arguments
    integer :: face_to_vertices(15)

    ! other variables
    integer :: ordered_table(15)
    logical :: defined_edges(15)
    integer :: next_edge, iver, jver, iedge, jedge, can_ver, can_edge
    real(8) :: r_ij(3), dist2, dist2_min

! *******************************************************************

    ! prepare
    ordered_table = 0
    defined_edges = .false.

    ! define first edge
    next_edge = 1
    defined_edges(next_edge) = .true.
    ordered_table(1) = face_to_vertices(next_edge)

    do iedge=2, nedge

        ! define the base edge
        iver = face_to_vertices(next_edge)

        dist2_min = 10000.0d0
        do jedge=2, nedge

            ! eliminate the connection defined
            if (defined_edges(jedge)) cycle

            jver = face_to_vertices(jedge)
            r_ij(:) = ver_crd(iver,:) - ver_crd(jver,:)

            dist2 = r_ij(1)**2 + r_ij(2)**2 + r_ij(3)**2

            if (dist2 < dist2_min) then
                dist2_min = dist2
                can_ver = jver
                can_edge = jedge
            endif
        enddo

        ordered_table(iedge) = can_ver
        next_edge = can_edge
        defined_edges(next_edge) = .true.

    enddo

    face_to_vertices = ordered_table

end subroutine


subroutine cal_volume(face_volume, face_to_vertices, nedge, ver_crd, nver)

! *******************************************************************
! ** Routine to calculate the volume of one face                   **
! *******************************************************************
    use limit

    implicit none

    ! output arguments
    real(8) :: face_volume

    ! input arguments
    integer :: nedge, nver
    integer :: face_to_vertices(15)
    real(8) :: ver_crd(maxver,3)

    ! other variables
    integer :: iver, jver, kver, jedge, kedge
    real(8) :: r_i(3), r_j(3), r_k(3), pyra_volume

    ! *******************************************************************

    face_volume = 0.0d0
    pyra_volume = 0.0d0

    ! define edge 1 as base edge 
    iver = face_to_vertices(1)       
    r_i(:) = ver_crd(iver, :)

    do jedge=2, nedge-1

        jver = face_to_vertices(jedge)
        r_j(:) = ver_crd(jver, :)

        kedge = jedge + 1
        kver = face_to_vertices(kedge)
        r_k(:) = ver_crd(kver, :)

        ! calculate the volume of pyramid
        pyra_volume = r_i(1)*r_j(2)*r_k(3) + r_i(2)*r_j(3)*r_k(1) &
                  & + r_i(3)*r_j(1)*r_k(2) - r_i(3)*r_j(2)*r_k(1) &
                  & - r_i(2)*r_j(1)*r_k(3) - r_i(1)*r_j(3)*r_k(2)

        if (pyra_volume >= 0.0d0) then
            face_volume = face_volume + pyra_volume/6.0d0
        else if (pyra_volume < 0.0d0) then
            face_volume = face_volume - pyra_volume/6.0d0
        endif

    enddo

end subroutine



subroutine cal_voronoi_all(radii, volumes, crd, target_atoms, & 
                         & is_enable_atoms, natom, ntar)

    use limit

    implicit none

    ! arguments
    integer, intent(in) :: natom, ntar
    integer, intent(in) :: target_atoms(ntar)
    logical, intent(in) :: is_enable_atoms(natom)
    real(8), intent(in) :: crd(natom, 3)

    ! return values
    real(8), intent(out):: radii(ntar), volumes(ntar)

    integer :: itar, iatm

    real(8) :: volume

    real(8), parameter :: hyd_volume = 8.0

    ! *******************************************************************
    ! ** MAIN LOOP STARTS                                              **
    ! *******************************************************************

    call set_crd(crd, natom)

    do itar=1, ntar
        iatm = target_atoms(itar)

        if ( is_enable_atoms(iatm) ) then

            call cal_voronoi_one(volume, iatm)
            volumes(itar) = volume

        else
            volumes(itar) = hyd_volume

        end if

    end do

    call cal_radii_sphere(radii, volumes, ntar)

end subroutine

subroutine cal_radii_gauss(radii, volumes, ntar_in)
    implicit none
    integer, intent(in) :: ntar_in
    real(8), intent(in) :: volumes(ntar_in)

    real(8), intent(out) :: radii(ntar_in)

    real(8) :: coef
    real(8), parameter :: pi = 3.141592653589793

    coef = 1.0/pi**(1.0/6.0)
    radii = coef * volumes**(1.0/3.0)

end subroutine

subroutine cal_radii_sphere(radii, volumes, ntar_in)
    implicit none
    integer, intent(in) :: ntar_in
    real(8), intent(in) :: volumes(ntar_in)

    real(8), intent(out) :: radii(ntar_in)

    real(8) :: coef
    real(8), parameter :: pi = 3.141592653589793

    coef = (3.0/(4.0*pi))**(1.0/6.0)
    radii = coef * volumes**(1.0/3.0)

end subroutine

module within_gpair

    implicit none
    integer :: npair
    integer, allocatable :: gpair_table(:, :) ! (npair, 3)
    integer, allocatable :: begins(:) ! (natom)
    integer, allocatable :: ends(:)   ! (natom)

    integer :: iatm, jatm
    integer :: i, ipair

contains

    subroutine setup(gpair_table_in, natom, npair_in)
        implicit none

        integer, intent(in) :: npair_in, natom
        integer, intent(in) :: gpair_table_in(npair_in, 3)

        npair = npair_in

        allocate(gpair_table(npair_in, 3))
        gpair_table = gpair_table_in
        allocate(begins(natom))
        allocate(ends(natom))

        call get_begins_ends(begins, ends, gpair_table, npair, natom)

    end subroutine

    logical function is_within_gpair(iatm, jatm)
        implicit none
        integer, intent(in) :: iatm, jatm
        integer :: jatm_beg, jatm_end

        is_within_gpair = .false.
        do ipair=begins(iatm), ends(iatm)
            jatm_beg = gpair_table(ipair, 2)
            jatm_end = gpair_table(ipair, 3)

            if ((jatm_beg<=jatm) .and. (jatm<=jatm_end)) then
                is_within_gpair = .true.
                exit
            end if
        end do

    end function

    subroutine get_nonbonded_table(nonbonded_table, ntable_new, &
                            & base_table, ntable)

        implicit none

        integer, intent(in) :: ntable
        integer, intent(in) :: base_table(ntable, 3)

        integer, intent(out) :: ntable_new
        integer, intent(out) :: nonbonded_table(ntable*10, 3)

        integer :: itab, jatm_beg, jatm_end, jatm_beg_new, jatm_end_new
        integer :: itab_new

        itab_new = 0
        do itab=1, ntable
            iatm     = base_table(itab, 1)
            jatm_beg = base_table(itab, 2)
            jatm_end = base_table(itab, 3)

            jatm_beg_new = 0
            jatm_end_new = jatm_beg

            do jatm=jatm_beg, jatm_end

                if (.not.is_within_gpair(iatm, jatm)) then

                    if (jatm_beg_new > 0) then
                        itab_new = itab_new + 1
                        nonbonded_table(itab_new, 1) = iatm
                        nonbonded_table(itab_new, 2) = jatm_beg_new
                        nonbonded_table(itab_new, 3) = jatm_end_new

                        jatm_beg_new = 0

                    end if

                else
                    if (jatm_beg_new == 0) jatm_beg_new = jatm
                    jatm_end_new = jatm

                end if

            end do

            if (jatm_beg_new > 0) then
                itab_new = itab_new + 1
                nonbonded_table(itab_new, 1) = iatm
                nonbonded_table(itab_new, 2) = jatm_beg_new
                nonbonded_table(itab_new, 3) = jatm_end_new
            
            end if

        end do

        ntable_new = itab_new

    end subroutine

    subroutine get_begins_ends(begins, ends, gpair_table, npair, natom)

        implicit none
        integer, intent(in) :: npair, natom
        integer, intent(in) :: gpair_table(npair, 3)

        integer, intent(out):: begins(natom)
        integer, intent(out):: ends(natom)

        integer :: nums(natom)

        integer :: ipair, iatm, jatm, iatm_prev

        begins(:) = 0
        nums(:)   = 0

        iatm_prev = 0
        do ipair=1, npair
            iatm     = gpair_table(ipair, 1)
            nums(iatm) = nums(iatm) + 1

            if (iatm /= iatm_prev) begins(iatm) = ipair
            iatm_prev = iatm
        end do

        do iatm=1, natom
            if (begins(iatm) == 0) then
                ends(iatm) = 0
            else
                ends(iatm) = begins(iatm) + nums(iatm) - 1
            end if
        end do

    end subroutine 


end module

!###############################################################################
module common_vars
    implicit none

    real(8), parameter :: PI = 3.141592653589793
    integer :: jint, itbf
    integer :: iatm, jatm, katm, latm
    integer :: iatm_beg, iatm_end, jatm_beg, jatm_end
    real(8), dimension(3) :: r_ij, r_ji, r_ik, r_ki, r_il, r_li
    real(8), dimension(3) :: r_jk, r_kj, r_jl, r_lj, r_kl, r_lk
    real(8) :: l_ij, l_ji, l_ik, l_ki, l_il, l_li
    real(8) :: l_jk, l_kj, l_jl, l_lj, l_kl, l_lk
    real(8) :: l_ij_inv
    real(8), dimension(3) :: f_ij, f_ik, f_il, f_jk, f_jl, f_kl
    real(8), dimension(3) :: f_i, f_j, f_k, f_l
    real(8) :: ene

contains

    function outer_prod(r1, r2)
        implicit none
        real(8), intent(in) :: r1(3)
        real(8), intent(in) :: r2(3)
        real(8) :: outer_prod(3)

        outer_prod(1) = r1(2)*r2(3) - r1(3)*r2(2)
        outer_prod(2) = r1(3)*r2(1) - r1(1)*r2(3)
        outer_prod(3) = r1(1)*r2(2) - r1(2)*r2(1)
        
    end function

    function check_tbforce(f1, f2)
        implicit none
        real(8), intent(in) :: f1(3)
        real(8), intent(in) :: f2(3)
        real(8) :: eps = 0.001d0, diff
        logical :: check_tbforce
        logical :: bool(3)
        integer :: d

        diff = sqrt(dot_product(f1, f1)) * eps

        do d=1, 3
            if (-eps < f1(d) .and. f1(d) < eps) then
                bool(d) = .true.
            else if ((f1(d)-diff < f2(d)) .and. (f2(d) < f1(d)+diff)) then
                bool(d) = .true.
            else
                bool(d) = .false.
            end if
        enddo

        if (bool(1) .and. bool(2) .and. bool(3)) then
            check_tbforce = .true.
        else
            check_tbforce = .false.
        endif

    end function

end module

!###############################################################################
module total
    implicit none
    logical :: check = .false. ! parameter
    integer :: natom   ! the number of atoms
    integer :: nbonded ! the number of bonded pairs
    real(8), allocatable :: crd(:, :) ! (natom, 3)
    ! itbf => (iatm, jatm)
    integer, allocatable :: bonded_pairs(:, :)    !(nbonded, 2)
    real(8), allocatable :: bonded_tbforces(:, :) !(nbonded, 3)
end module

!###############################################################################
module bond
    implicit none
    ! input
    integer, allocatable :: two_atoms(:,:)  ! (nbond, 2)
    real(8), allocatable :: force_consts(:) ! (nbond)
    real(8), allocatable :: length_eqs(:)   ! (nbond)
    integer, allocatable :: ibnd_to_itbf(:) ! (nbond)
    ! output
    real(8) :: energy
    real(8), allocatable :: forces(:, :)   ! (natom, 3)
    real(8), allocatable :: tbforces(:, :) ! (ntbf,  3)
    real(8), allocatable :: displacement(:, :)! (ntbf, 3)

    ! main variales
    integer :: ibnd, nbond, itbf_ij
    integer :: iatm, jatm

contains
    subroutine calculate()
        use total
        use common_vars
        implicit none
        real(8) :: kb, l_eq

        ! for each bond,
        ! E_bond = K_b (l_ij - l_eq)^2
        
        ! F_i = - 2 K_b (l_ij - l_eq) r_ij/l_ij
        ! F_j = - F_i

        ! F_ij = - 2 K_b (l_ij - l_eq) r_ij/l_ij
        ! F_ji = - F_ij

        ! initialization
        nbond    = size(force_consts)
        energy   = 0.0d0
        forces   = 0.0d0
        tbforces = 0.0d0
        displacement = 0.0d0

        do ibnd=1, nbond
            itbf_ij = ibnd_to_itbf(ibnd) ! => ij
            iatm    = two_atoms(ibnd, 1)
            jatm    = two_atoms(ibnd, 2)

            kb   = force_consts(ibnd)
            l_eq = length_eqs(ibnd)

            r_ij = crd(iatm, :) - crd(jatm, :)
            l_ij = sqrt( dot_product(r_ij, r_ij) )

            ! calculate energy
            ene = kb * (l_ij - l_eq) ** 2
            energy = energy + ene

            ! calculate force
            f_i = - 2.0 * kb * (l_ij - l_eq)/l_ij * r_ij

            ! store force
            forces(iatm, :) = forces(iatm, :) + f_i(:)
            forces(jatm, :) = forces(jatm, :) - f_i(:)

            ! calculate two-body force
            f_ij = f_i

            ! store two-body force and two-body distance vector
            if (itbf_ij > 0) then
                tbforces(itbf_ij,:) = tbforces(itbf_ij,:) + f_ij(:)
                displacement(itbf_ij,:) = r_ij(:)
            else
                tbforces(-itbf_ij,:) = tbforces(-itbf_ij,:) - f_ij(:)
                displacement(-itbf_ij,:) = -r_ij(:)
            end if

            ! check
            if (check) then
                print*, 'TB_CHECK: i, j =', iatm, jatm
                print*, 'TB_CHECK: f_i vs. f_ij =>', check_tbforce(f_i, f_ij)
                print*, 'TB_CHECK:',f_i
                print*, 'TB_CHECK:',f_ij
                print*, 'TB_CHECK: f_j vs. f_ji =>', check_tbforce(-f_i, -f_ij)
                print*, 'TB_CHECK:',-f_i
                print*, 'TB_CHECK:',-f_ij
            end if

        enddo
        
    end subroutine

    subroutine print_tbforce()
        use total, only: bonded_pairs, nbonded
        use common_vars
        implicit none
        real(8) :: tbf_abs

        do itbf=1, nbonded
            iatm = bonded_pairs(itbf, 1)
            jatm = bonded_pairs(itbf, 2)

            tbf_abs = dot_product(tbforces(itbf,:), tbforces(itbf,:))
            if (-0.0001 < tbf_abs .and. tbf_abs < 0.0001) cycle
            write(*, '(2I5,3F15.7)'), iatm, jatm, tbforces(itbf_ij, :)
         end do
            
    end subroutine

    subroutine print_atom_order()
        use total, only: bonded_pairs
        use common_vars
        implicit none
        integer :: iatm_, jatm_

        print*, '** print atom order for bond **'
        nbond = size(force_consts)
        do ibnd=1, nbond
            iatm = two_atoms(ibnd,1)
            jatm = two_atoms(ibnd,2)

            itbf_ij = ibnd_to_itbf(ibnd)
            if (itbf_ij > 0) then
                iatm_ = bonded_pairs(itbf_ij, 1)
                jatm_ = bonded_pairs(itbf_ij, 2)
            else
                iatm_ = bonded_pairs(-itbf_ij, 2)
                jatm_ = bonded_pairs(-itbf_ij, 1)
            end if

            print*, ibnd
            print*, iatm, iatm_
            print*, jatm, jatm_

         end do
            
    end subroutine

end module

!###############################################################################
module angle
    implicit none
    ! input
    integer, allocatable :: three_atoms(:,:)  ! (nangle, 3)
    real(8), allocatable :: force_consts(:)   ! (nangle)
    real(8), allocatable :: theta_eqs(:)      ! (nangle)
    integer, allocatable :: iang_to_itbf(:,:) ! (nangle, 3)
    ! output
    real(8) :: energy
    real(8), allocatable :: forces(:, :)   ! (natom, 3)
    real(8), allocatable :: tbforces(:, :) ! (ntbf, 3)
    real(8), allocatable :: displacement(:, :) ! (ntbf, 3)

    ! main variales
    integer :: iang, nangle, itbf_ij, itbf_ik, itbf_jk
    integer :: iatm, jatm, katm

contains
    subroutine calculate()
        use total
        use common_vars
        implicit none
        real(8) :: ka, theta_eq, cos_theta, theta, coeff, sin_theta
        real(8), parameter :: eps = 1.0d-10

        ! Energy:
        ! E_angle = K_a (theta_ijk - theta_eq)^2

        ! Force:
        ! A = 2 K_a (theta - theta_eq) / sin(theta)
        ! F_i = A/ (r_kj/l_kj )

        ! two-body force:
        ! A = 2 K_a (theta - theta_eq) / sin(theta)
        ! F_ij = A/l_ij (1/l_kj - cos(theta)/l_ij) r_ij
        ! F_ik = -A/(l_ij l_kj) r_ik
        ! F_jk = A/l_kj (1/l_ij - cos(theta)/l_kj) r_jk

        ! initialization
        nangle   = size(force_consts)
        energy   = 0.0d0
        forces   = 0.0d0
        tbforces = 0.0d0
        displacement = 0.0d0

        do iang=1, nangle
            itbf_ij = iang_to_itbf(iang, 1) ! => ij
            itbf_ik = iang_to_itbf(iang, 2) ! => ik
            itbf_jk = iang_to_itbf(iang, 3) ! => jk

            iatm     = three_atoms(iang, 1)
            jatm     = three_atoms(iang, 2)
            katm     = three_atoms(iang, 3)

            ka       = force_consts(iang)
            theta_eq = theta_eqs(iang)

            r_ij = crd(iatm, :) - crd(jatm, :)
            r_kj = crd(katm, :) - crd(jatm, :)
            r_ik = crd(iatm, :) - crd(katm, :)
            l_ij = sqrt( dot_product(r_ij, r_ij) )
            l_kj = sqrt( dot_product(r_kj, r_kj) )

            ! calculate theta
            cos_theta = dot_product(r_ij, r_kj) / (l_ij*l_kj)
            if (cos_theta >  1.0d0) cos_theta =  1.0d0
            if (cos_theta < -1.0d0) cos_theta = -1.0d0
            theta = acos(cos_theta)

            ! calculate energy
            ene = ka * (theta - theta_eq) ** 2
            energy = energy + ene

            ! calculate force
            sin_theta = sin(theta)
            if (sin_theta < eps) sin_theta = eps ! for sin(theta) == 0
            coeff = 2 * ka * (theta-theta_eq)/sin_theta

            f_i = coeff/l_ij * (r_kj/l_kj - cos_theta*r_ij/l_ij)
            f_k = coeff/l_kj * (r_ij/l_ij - cos_theta*r_kj/l_kj)

            ! store force
            forces(iatm, :) = forces(iatm, :) + f_i(:)
            forces(jatm, :) = forces(jatm, :) - f_i(:) - f_k(:)
            forces(katm, :) = forces(katm, :) + f_k(:)

            ! calculate two-body-force
            f_ij =   coeff/l_ij * (1.0d0/l_kj - cos_theta/l_ij) * r_ij
            f_ik = - coeff/(l_ij*l_kj) * r_ik
            f_jk =   coeff/l_kj * (1.0d0/l_ij - cos_theta/l_kj) * (-r_kj)

            ! store two-body force and two-body distance vector
            if (itbf_ij > 0) then
                tbforces(itbf_ij,:) = tbforces(itbf_ij,:) + f_ij(:)
                displacement(itbf_ij,:) = r_ij(:)
            else
                tbforces(-itbf_ij,:) = tbforces(-itbf_ij,:) - f_ij(:)
                displacement(-itbf_ij,:) = -r_ij(:)
            end if

            if (itbf_ik > 0) then
                tbforces(itbf_ik,:) = tbforces(itbf_ik,:) + f_ik(:)
                displacement(itbf_ik,:) = r_ik(:)
            else
                tbforces(-itbf_ik,:) = tbforces(-itbf_ik,:) - f_ik(:)
                displacement(-itbf_ik,:) = -r_ik(:)
            end if

            if (itbf_jk > 0) then
                tbforces(itbf_jk,:) = tbforces(itbf_jk,:) + f_jk(:)
                displacement(itbf_jk,:) = -r_kj(:)
            else
                tbforces(-itbf_jk,:) = tbforces(-itbf_jk,:) - f_jk(:)
                displacement(-itbf_jk,:) = r_kj(:)
            end if

            if (check) then
                print*, 'TB_CHECK:','i, j, k =', iatm, jatm, katm
                print*, 'TB_CHECK: f_i vs. f_ij + f_ik =>', &
                    & check_tbforce(f_i, f_ij+f_ik)
                print*, 'TB_CHECK:',f_i
                print*, 'TB_CHECK:',f_ij + f_ik
                print*, 'TB_CHECK: f_j vs. f_ji + f_jk =>', & 
                    & check_tbforce(-f_i-f_k, -f_ij+f_jk)
                print*, 'TB_CHECK:',-f_i - f_k
                print*, 'TB_CHECK:',-f_ij + f_jk
                print*, 'TB_CHECK: f_k vs. f_ki + f_kj =>', &
                    & check_tbforce(f_k, -f_ik-f_jk)
                print*, 'TB_CHECK:',f_k
                print*, 'TB_CHECK:',-f_ik - f_jk
            end if

        enddo

    end subroutine

    subroutine print_tbforce()
        use total, only: bonded_pairs, nbonded
        use common_vars
        implicit none
        real(8) :: tbf_abs

        do itbf=1, nbonded
            iatm = bonded_pairs(itbf, 1)
            jatm = bonded_pairs(itbf, 2)

            tbf_abs = dot_product(tbforces(itbf,:), tbforces(itbf,:))
            if (-0.0001 < tbf_abs .and. tbf_abs < 0.0001) cycle
            write(*, '(2I5,3F15.7)'), iatm, jatm, tbforces(itbf_ij, :)
         end do
            
    end subroutine

    subroutine print_atom_order()
        use total, only: bonded_pairs
        use common_vars
        implicit none
        integer :: iatoms(2), jatoms(2), katoms(2)

        print*, '** print atom order for angle **'
        nangle   = size(force_consts)
        do iang=1, nangle
            iatm = three_atoms(iang,1)
            jatm = three_atoms(iang,2)
            katm = three_atoms(iang,3)

            itbf_ij = iang_to_itbf(iang,1)
            if (itbf_ij > 0) then
                iatoms(1) = bonded_pairs(itbf_ij, 1)
                jatoms(1) = bonded_pairs(itbf_ij, 2)
            else
                iatoms(1) = bonded_pairs(-itbf_ij, 2)
                jatoms(1) = bonded_pairs(-itbf_ij, 1)
            end if

            itbf_ik = iang_to_itbf(iang, 2)
            if (itbf_ik > 0) then
                iatoms(2) = bonded_pairs(itbf_ik, 1)
                katoms(1) = bonded_pairs(itbf_ik, 2)
            else
                iatoms(2) = bonded_pairs(-itbf_ik, 2)
                katoms(1) = bonded_pairs(-itbf_ik, 1)
            end if

            itbf_jk = iang_to_itbf(iang, 3)
            if (itbf_jk > 0) then
                jatoms(2) = bonded_pairs(itbf_jk, 1)
                katoms(2) = bonded_pairs(itbf_jk, 2)
            else
                jatoms(2) = bonded_pairs(-itbf_jk, 2)
                katoms(2) = bonded_pairs(-itbf_jk, 1)
            end if

            print*, iang
            print*, iatm, iatoms
            print*, jatm, jatoms
            print*, katm, katoms

         end do
            
    end subroutine

end module

module torsion
    implicit none
    ! input
    integer, allocatable :: four_atoms(:,:)   ! (ntorsion, 4)
    integer, allocatable :: num_torsions(:)   ! (ntorsion)
    integer, allocatable :: num_freqs(:)      ! (ntorsion)
    real(8), allocatable :: force_consts(:)   ! (ntorsion)
    real(8), allocatable :: initial_phases(:) ! (ntorsion)
    integer, allocatable :: itor_to_itbf(:,:) ! (ntorsion, 6)
    ! output
    real(8) :: energy
    real(8), allocatable :: forces(:, :)   ! (natom, 3)
    real(8), allocatable :: tbforces(:, :) ! (ntfb, 3)
    real(8), allocatable :: displacement(:, :) ! (ntbf, 3)

    ! main variales
    integer :: itor, ntorsion
    integer :: iatm, jatm, katm, latm
    integer :: itbf_ij, itbf_ik, itbf_il, itbf_jk, itbf_jl, itbf_kl

contains
    subroutine calculate()
        use total
        use common_vars
        implicit none
        real(8) :: kt, coeff, cos_phi, sin_phi, phi, new_phi, judge
        real(8) :: f_a, f_b(3), f_c(3), n_1(3), n_2(3), l_1, l_2
        integer :: nfreq
        real(8), parameter :: eps = 1.0d-10

        ! Energy:
        ! E_torsion = K_t [1 + cos(eta phi - gamma)]

        ! Force:
        ! f_a = - K_t*ita/2 sin(ita*phi - gamma) / sin(phi)
        ! f_b = (n_2/l_2 - cos(phi)*n_1/l_1) / l_1
        ! f_c = (n_1/l_1 - cos(phi)*n_2/l_2) / l_2
        !
        ! when sin(phi) is nearly equal to 0,
        ! f_a = 
        ! if eta == 1 then  cos(gamma)
        ! if eta == 2 then  2cos(phi)*cos(gamma)
        ! if eta == 3 then  (-4sin(phi)^2 + 3) cos(gamma)
        ! if eta == 4 then  (4(cos(phi)(2cos(phi)^2 -1))) cos(gamma)
        ! if eta == 5 then  (1 + 4*cos(phi)^2 (1-4*sin(phi)^2))) cos(gamma)
        ! if eta == 6 then 

        ! F_i = f_a (f_b x r_jk)
        ! F_j = f_a (f_c x r_kl - f_b x r_ik)
        ! F_k = f_a (f_b x r_ij - f_c x r_jl)
        ! F_l = f_a (f_c x r_jk)

        ! initialization
        ntorsion = size(force_consts)
        energy   = 0.0d0
        forces   = 0.0d0
        tbforces = 0.0d0
        displacement = 0.0d0

        ! print*, num_torsions

        do itor=1, ntorsion

            ! If force constant of torsional energy is small value that 
            ! less than eps, then do not calculate it
            if( dabs( force_consts(itor) ) <= eps ) cycle

            itbf_ij = itor_to_itbf(itor, 1) ! => ij
            itbf_ik = itor_to_itbf(itor, 2) ! => ik
            itbf_il = itor_to_itbf(itor, 3) ! => il
            itbf_jk = itor_to_itbf(itor, 4) ! => jk
            itbf_jl = itor_to_itbf(itor, 5) ! => jl
            itbf_kl = itor_to_itbf(itor, 6) ! => kl

            iatm  = four_atoms(itor, 1)
            jatm  = four_atoms(itor, 2)
            katm  = four_atoms(itor, 3)
            latm  = four_atoms(itor, 4)
            kt    = force_consts(itor)
            nfreq = num_freqs(itor)

            r_ij = crd(iatm,:) - crd(jatm,:)
            r_ik = crd(iatm,:) - crd(katm,:)
            r_il = crd(iatm,:) - crd(latm,:)
            r_jk = crd(jatm,:) - crd(katm,:)
            r_jl = crd(jatm,:) - crd(latm,:)
            r_kl = crd(katm,:) - crd(latm,:)
            l_ij = sqrt( dot_product(r_ij, r_ij) )
            l_ik = sqrt( dot_product(r_ik, r_ik) )
            l_il = sqrt( dot_product(r_il, r_il) )
            l_jk = sqrt( dot_product(r_jk, r_jk) )
            l_jl = sqrt( dot_product(r_jl, r_jl) )
            l_kl = sqrt( dot_product(r_kl, r_kl) )

            ! make normal vector
            n_1 = outer_prod(r_ij, -r_jk)
            n_2 = outer_prod(-r_jk, r_kl)
            l_1 = sqrt( dot_product(n_1, n_1) )
            l_2 = sqrt( dot_product(n_2, n_2) )
            ! l_1 = sqrt( dot_product(r_kl, r_kl) )
            ! l_2 = sqrt( dot_product(r_kl, r_kl) )

            cos_phi = dot_product(n_1, n_2)/(l_1*l_2)
            if (cos_phi >  1.0d0) cos_phi =  1.0d0
            if (cos_phi < -1.0d0) cos_phi = -1.0d0

            ! judge sign and calculate phi
            phi = acos(cos_phi)
            judge = -dot_product(-r_jk, outer_prod(n_1, n_2))
            if (judge < 0.0d0) phi = 2.0d0*PI - phi

            ! calculate energy
            new_phi = nfreq*phi + initial_phases(itor)
            ene = kt * (1.0d0 + cos(new_phi)) / num_torsions(itor)
            energy = energy + ene

            ! calculate force
            ! when phi = 0.0d0
            sin_phi = sin(phi)
            if (nfreq == 1) then
                coeff = 1.0d0
            else if (nfreq == 2) then
                coeff = 2.0d0 * cos_phi
            else if (nfreq == 3) then
                coeff = 3.0d0 - 4.0d0 * sin_phi**2
            else if (nfreq == 4) then
                coeff = (4.0d0 - 8.0d0*sin_phi**2) * cos_phi
            else if (nfreq == 5) then
                coeff = (16.0d0*sin_phi**2 - 20.0d0) * (sin_phi**2) + 5.0d0
            else if (nfreq == 6) then
                coeff = 32.0d0*(cos_phi**2)*(cos_phi**2 - 1.0d0)
                coeff = cos_phi * (6.0d0 + coeff)
            end if
            coeff = coeff * cos(initial_phases(itor))

            f_a = - kt*nfreq*coeff/num_torsions(itor)

            f_b = (n_2/l_2 - cos(phi)*n_1/l_1) / l_1
            f_c = (n_1/l_1 - cos(phi)*n_2/l_2) / l_2

            f_i = f_a * outer_prod(f_b, r_jk)
            f_j = f_a * ( outer_prod(f_c, r_kl) - outer_prod(f_b, r_ik) )
            f_k = f_a * ( outer_prod(f_b, r_ij) - outer_prod(f_c, r_jl) )
            f_l = f_a * outer_prod(f_c, r_jk)

            ! store force
            forces(iatm, :) = forces(iatm, :) + f_i(:)
            forces(jatm, :) = forces(jatm, :) + f_j(:)
            forces(katm, :) = forces(katm, :) + f_k(:)
            forces(latm, :) = forces(latm, :) + f_l(:)

            ! calculate two-body-force
            f_ij = f_a/l_1 * ( dot_product(-r_jk, r_kl)/l_2 &
            &                + dot_product(-r_jk, r_ik)*cos_phi/l_1 ) * r_ij

            f_ik = f_a/l_1 * ( dot_product(-r_jk, -r_jl)/l_2 &
            &                - dot_product(r_ij, -r_jk)*cos_phi/l_1 ) * r_ik

            f_il = - f_a * dot_product(r_jk, r_jk) / (l_1*l_2) * r_il

            f_jk = - f_a * ( dot_product(r_kl, r_ij)/(l_1*l_2) &
            &              + dot_product(r_ik, r_jl)/(l_1*l_2) &
            &              + dot_product(r_ij, r_ik)*cos_phi/(l_1**2) &
            &              + dot_product(r_kl, r_jl)*cos_phi/(l_2**2) ) * r_jk

            f_jl = f_a/l_2 * ( dot_product(r_ik, r_jk)/l_1 &
            &                - dot_product(-r_jk, r_kl)*cos_phi/l_2 ) * r_jl

            f_kl = f_a/l_2 * ( dot_product(r_ij, -r_jk)/l_1 &
            &                - dot_product(-r_jk, -r_jl)*cos_phi/l_2) * r_kl

            ! store two-body force and two-body distance vector
            if (itbf_ij > 0) then
                tbforces(itbf_ij,:) = tbforces(itbf_ij,:) + f_ij(:)
                displacement(itbf_ij,:) = r_ij(:)
            else
                tbforces(-itbf_ij,:) = tbforces(-itbf_ij,:) - f_ij(:)
                displacement(-itbf_ij,:) = -r_ij(:)
            end if

            if (itbf_ik > 0) then
                tbforces(itbf_ik,:) = tbforces(itbf_ik,:) + f_ik(:)
                displacement(itbf_ik,:) = r_ik(:)
            else
                tbforces(-itbf_ik,:) = tbforces(-itbf_ik,:) - f_ik(:)
                displacement(-itbf_ik,:) = -r_ik(:)
            end if

            if (itbf_il > 0) then
                tbforces(itbf_il,:) = tbforces(itbf_il,:) + f_il(:)
                displacement(itbf_il,:) = r_il(:)
            else
                tbforces(-itbf_il,:) = tbforces(-itbf_il,:) - f_il(:)
                displacement(-itbf_il,:) = -r_il(:)
            end if

            if (itbf_jk > 0) then
                tbforces(itbf_jk,:) = tbforces(itbf_jk,:) + f_jk(:)
                displacement(itbf_jk,:) = r_jk(:)
            else
                tbforces(-itbf_jk,:) = tbforces(-itbf_jk,:) - f_jk(:)
                displacement(-itbf_jk,:) = -r_jk(:)
            end if

            if (itbf_jl > 0) then
                tbforces(itbf_jl,:) = tbforces(itbf_jl,:) + f_jl(:)
                displacement(itbf_jl,:) = r_jl(:)
            else
                tbforces(-itbf_jl,:) = tbforces(-itbf_jl,:) - f_jl(:)
                displacement(-itbf_jl,:) = -r_jl(:)
            end if

            if (itbf_kl > 0) then
                tbforces(itbf_kl,:) = tbforces(itbf_kl,:) + f_kl(:)
                displacement(itbf_kl,:) = r_kl(:)
            else
                tbforces(-itbf_kl,:) = tbforces(-itbf_kl,:) - f_kl(:)
                displacement(-itbf_kl,:) = -r_kl(:)
            end if

            if (check) then
                print*, 'TB_CHECK: i, j, k, l=', iatm, jatm, katm, latm
                print*, 'TB_CHECK: f_i vs. f_ij + f_ik + f_il =>', &
                    & check_tbforce(f_i, f_ij+f_ik+f_il)
                print*, 'TB_CHECK:',f_i
                print*, 'TB_CHECK:',f_ij + f_ik + f_il
                print*, 'TB_CHECK: f_j vs. f_ji + f_jk + f_jl =>', & 
                    & check_tbforce(f_j, -f_ij+f_jk+f_jl)
                print*, 'TB_CHECK:',f_j
                print*, 'TB_CHECK:',- f_ij + f_jk + f_jl
                print*, 'TB_CHECK: f_k vs. f_ki + f_kj + f_kl =>', &
                    & check_tbforce(f_k, -f_ik-f_jk+f_kl)
                print*, 'TB_CHECK:',f_k
                print*, 'TB_CHECK:',- f_ik - f_jk + f_kl
                print*, 'TB_CHECK: f_l vs. f_li + f_lj + f_lk =>', &
                    & check_tbforce(f_l, -f_il-f_jl-f_kl)
                print*, 'TB_CHECK:',f_l
                print*, 'TB_CHECK:',- f_il - f_jl - f_kl
            end if

        enddo

    end subroutine

    subroutine print_tbforce()
        use total, only: bonded_pairs, nbonded
        use common_vars
        implicit none
        real(8) :: tbf_abs

        do itbf=1, nbonded
            iatm = bonded_pairs(itbf, 1)
            jatm = bonded_pairs(itbf, 2)

            tbf_abs = dot_product(tbforces(itbf,:), tbforces(itbf,:))
            if (-0.0001 < tbf_abs .and. tbf_abs < 0.0001) cycle
            write(*, '(2I5,3F15.7)'), iatm, jatm, tbforces(itbf_ij, :)
         end do
            
    end subroutine

    subroutine print_atom_order()
        use total, only: bonded_pairs
        use common_vars
        implicit none
        integer :: iatoms(3), jatoms(3), katoms(3), latoms(3)

        print*, '** print atom order for torsion **'
        ntorsion = size(force_consts)
        do itor=1, ntorsion
            iatm = four_atoms(itor,1)
            jatm = four_atoms(itor,2)
            katm = four_atoms(itor,3)
            latm = four_atoms(itor,4)

            itbf_ij = itor_to_itbf(itor, 1)
            if (itbf_ij > 0) then
                iatoms(1) = bonded_pairs(itbf_ij, 1)
                jatoms(1) = bonded_pairs(itbf_ij, 2)
            else
                iatoms(1) = bonded_pairs(-itbf_ij, 2)
                jatoms(1) = bonded_pairs(-itbf_ij, 1)
            end if

            itbf_ik = itor_to_itbf(itor, 2)
            if (itbf_ik > 0) then
                iatoms(2) = bonded_pairs(itbf_ik, 1)
                katoms(1) = bonded_pairs(itbf_ik, 2)
            else
                iatoms(2) = bonded_pairs(-itbf_ik, 2)
                katoms(1) = bonded_pairs(-itbf_ik, 1)
            end if

            itbf_il = itor_to_itbf(itor, 3)
            if (itbf_il > 0) then
                iatoms(3) = bonded_pairs(itbf_il, 1)
                latoms(1) = bonded_pairs(itbf_il, 2)
            else
                iatoms(3) = bonded_pairs(-itbf_il, 2)
                latoms(1) = bonded_pairs(-itbf_il, 1)
            end if

            itbf_jk = itor_to_itbf(itor, 4)
            if (itbf_jk > 0) then
                jatoms(2) = bonded_pairs(itbf_jk, 1)
                katoms(2) = bonded_pairs(itbf_jk, 2)
            else
                jatoms(2) = bonded_pairs(-itbf_jk, 2)
                katoms(2) = bonded_pairs(-itbf_jk, 1)
            end if

            itbf_jl = itor_to_itbf(itor, 5)
            if (itbf_jl > 0) then
                jatoms(3) = bonded_pairs(itbf_jl, 1)
                latoms(2) = bonded_pairs(itbf_jl, 2)
            else
                jatoms(3) = bonded_pairs(-itbf_jl, 2)
                latoms(2) = bonded_pairs(-itbf_jl, 1)
            end if

            itbf_kl = itor_to_itbf(itor, 6)
            if (itbf_kl > 0) then
                katoms(3) = bonded_pairs(itbf_kl, 1)
                latoms(3) = bonded_pairs(itbf_kl, 2)
            else
                katoms(3) = bonded_pairs(-itbf_kl, 2)
                latoms(3) = bonded_pairs(-itbf_kl, 1)
            end if

            print*, itor
            print*, iatm, iatoms
            print*, jatm, jatoms
            print*, katm, katoms
            print*, latm, latoms

         end do
            
    end subroutine

end module

module improper
    implicit none
    ! input
    integer, allocatable :: four_atoms(:,:)   ! (ntorsion, 4)
    integer, allocatable :: num_torsions(:)   ! (ntorsion)
    integer, allocatable :: num_freqs(:)      ! (ntorsion)
    real(8), allocatable :: force_consts(:)   ! (ntorsion)
    real(8), allocatable :: initial_phases(:) ! (ntorsion)
    integer, allocatable :: itor_to_itbf(:,:) ! (ntorsion, 6)
    ! output
    real(8) :: energy
    real(8), allocatable :: forces(:, :)   ! (natom, 3)
    real(8), allocatable :: tbforces(:, :) ! (ntfb, 3)
    real(8), allocatable :: displacement(:, :)! (ntbf, 3)

    ! main variales
    integer :: itor, ntorsion
    integer :: iatm, jatm, katm, latm
    integer :: itbf_ij, itbf_ik, itbf_il, itbf_jk, itbf_jl, itbf_kl

contains
    subroutine calculate()
        use total
        use common_vars
        implicit none
        real(8) :: kt, coeff, cos_phi, sin_phi, phi, new_phi, judge
        real(8) :: f_a, f_b(3), f_c(3), n_1(3), n_2(3), l_1, l_2
        integer :: nfreq
        real(8), parameter :: eps = 1.0d-10

        ! Energy:
        ! E_torsion = K_t [1 + cos(eta phi - gamma)]

        ! Force:
        ! f_a = - K_t*ita/2 sin(ita*phi - gamma) / sin(phi)
        ! f_b = (n_2/l_2 - cos(phi)*n_1/l_1) / l_1
        ! f_c = (n_1/l_1 - cos(phi)*n_2/l_2) / l_2
        !
        ! when sin(phi) is nearly equal to 0,
        ! f_a = 
        ! if eta == 1 then  cos(gamma)
        ! if eta == 2 then  2cos(phi)*cos(gamma)
        ! if eta == 3 then  (-4sin(phi)^2 + 3) cos(gamma)
        ! if eta == 4 then  (4(cos(phi)(2cos(phi)^2 -1))) cos(gamma)
        ! if eta == 5 then  (1 + 4*cos(phi)^2 (1-4*sin(phi)^2))) cos(gamma)
        ! if eta == 6 then 

        ! F_i = f_a (f_b x r_jk)
        ! F_j = f_a (f_c x r_kl - f_b x r_ik)
        ! F_k = f_a (f_b x r_ij - f_c x r_jl)
        ! F_l = f_a (f_c x r_jk)

        ! initialization
        ntorsion = size(force_consts)
        energy   = 0.0d0
        forces   = 0.0d0
        tbforces = 0.0d0
        displacement = 0.0d0

        ! print*, num_torsions

        do itor=1, ntorsion

            ! If force constant of torsional energy is small value that 
            ! less than eps, then do not calculate it
            if( dabs( force_consts(itor) ) <= eps ) cycle

            itbf_ij = itor_to_itbf(itor, 1) ! => ij
            itbf_ik = itor_to_itbf(itor, 2) ! => ik
            itbf_il = itor_to_itbf(itor, 3) ! => il
            itbf_jk = itor_to_itbf(itor, 4) ! => jk
            itbf_jl = itor_to_itbf(itor, 5) ! => jl
            itbf_kl = itor_to_itbf(itor, 6) ! => kl

            iatm  = four_atoms(itor, 1)
            jatm  = four_atoms(itor, 2)
            katm  = four_atoms(itor, 3)
            latm  = four_atoms(itor, 4)
            kt    = force_consts(itor)
            nfreq = num_freqs(itor)

            r_ij = crd(iatm,:) - crd(jatm,:)
            r_ik = crd(iatm,:) - crd(katm,:)
            r_il = crd(iatm,:) - crd(latm,:)
            r_jk = crd(jatm,:) - crd(katm,:)
            r_jl = crd(jatm,:) - crd(latm,:)
            r_kl = crd(katm,:) - crd(latm,:)
            l_ij = sqrt( dot_product(r_ij, r_ij) )
            l_ik = sqrt( dot_product(r_ik, r_ik) )
            l_il = sqrt( dot_product(r_il, r_il) )
            l_jk = sqrt( dot_product(r_jk, r_jk) )
            l_jl = sqrt( dot_product(r_jl, r_jl) )
            l_kl = sqrt( dot_product(r_kl, r_kl) )

            ! make normal vector
            n_1 = outer_prod(r_ij, -r_jk)
            n_2 = outer_prod(-r_jk, r_kl)
            l_1 = sqrt( dot_product(n_1, n_1) )
            l_2 = sqrt( dot_product(n_2, n_2) )
            ! l_1 = sqrt( dot_product(r_kl, r_kl) )
            ! l_2 = sqrt( dot_product(r_kl, r_kl) )

            cos_phi = dot_product(n_1, n_2)/(l_1*l_2)
            if (cos_phi >  1.0d0) cos_phi =  1.0d0
            if (cos_phi < -1.0d0) cos_phi = -1.0d0

            ! judge sign and calculate phi
            phi = acos(cos_phi)
            judge = -dot_product(-r_jk, outer_prod(n_1, n_2))
            if (judge < 0.0d0) phi = 2.0d0*PI - phi

            ! calculate energy
            new_phi = nfreq*phi + initial_phases(itor)
            ene = kt * (1.0d0 + cos(new_phi)) / num_torsions(itor)
            energy = energy + ene

            ! calculate force
            ! when phi = 0.0d0
            sin_phi = sin(phi)
            if (nfreq == 1) then
                coeff = 1.0d0
            else if (nfreq == 2) then
                coeff = 2.0d0 * cos_phi
            else if (nfreq == 3) then
                coeff = 3.0d0 - 4.0d0 * sin_phi**2
            else if (nfreq == 4) then
                coeff = (4.0d0 - 8.0d0*sin_phi**2) * cos_phi
            else if (nfreq == 5) then
                coeff = (16.0d0*sin_phi**2 - 20.0d0) * (sin_phi**2) + 5.0d0
            else if (nfreq == 6) then
                coeff = 32.0d0*(cos_phi**2)*(cos_phi**2 - 1.0d0)
                coeff = cos_phi * (6.0d0 + coeff)
            end if
            coeff = coeff * cos(initial_phases(itor))

            f_a = - kt*nfreq*coeff/num_torsions(itor)

            f_b = (n_2/l_2 - cos(phi)*n_1/l_1) / l_1
            f_c = (n_1/l_1 - cos(phi)*n_2/l_2) / l_2

            f_i = f_a * outer_prod(f_b, r_jk)
            f_j = f_a * ( outer_prod(f_c, r_kl) - outer_prod(f_b, r_ik) )
            f_k = f_a * ( outer_prod(f_b, r_ij) - outer_prod(f_c, r_jl) )
            f_l = f_a * outer_prod(f_c, r_jk)

            ! store force
            forces(iatm, :) = forces(iatm, :) + f_i(:)
            forces(jatm, :) = forces(jatm, :) + f_j(:)
            forces(katm, :) = forces(katm, :) + f_k(:)
            forces(latm, :) = forces(latm, :) + f_l(:)

            ! calculate two-body-force
            f_ij = f_a/l_1 * ( dot_product(-r_jk, r_kl)/l_2 &
            &                + dot_product(-r_jk, r_ik)*cos_phi/l_1 ) * r_ij

            f_ik = f_a/l_1 * ( dot_product(-r_jk, -r_jl)/l_2 &
            &                - dot_product(r_ij, -r_jk)*cos_phi/l_1 ) * r_ik

            f_il = - f_a * dot_product(r_jk, r_jk) / (l_1*l_2) * r_il

            f_jk = - f_a * ( dot_product(r_kl, r_ij)/(l_1*l_2) &
            &              + dot_product(r_ik, r_jl)/(l_1*l_2) &
            &              + dot_product(r_ij, r_ik)*cos_phi/(l_1**2) &
            &              + dot_product(r_kl, r_jl)*cos_phi/(l_2**2) ) * r_jk

            f_jl = f_a/l_2 * ( dot_product(r_ik, r_jk)/l_1 &
            &                - dot_product(-r_jk, r_kl)*cos_phi/l_2 ) * r_jl

            f_kl = f_a/l_2 * ( dot_product(r_ij, -r_jk)/l_1 &
            &                - dot_product(-r_jk, -r_jl)*cos_phi/l_2) * r_kl

            ! store two-body force and two-body distance vector
            if (itbf_ij > 0) then
                tbforces(itbf_ij,:) = tbforces(itbf_ij,:) + f_ij(:)
                displacement(itbf_ij,:) = r_ij(:)
            else
                tbforces(-itbf_ij,:) = tbforces(-itbf_ij,:) - f_ij(:)
                displacement(-itbf_ij,:) = -r_ij(:)
            end if

            if (itbf_ik > 0) then
                tbforces(itbf_ik,:) = tbforces(itbf_ik,:) + f_ik(:)
                displacement(itbf_ik,:) = r_ik(:)
            else
                tbforces(-itbf_ik,:) = tbforces(-itbf_ik,:) - f_ik(:)
                displacement(-itbf_ik,:) = -r_ik(:)
            end if

            if (itbf_il > 0) then
                tbforces(itbf_il,:) = tbforces(itbf_il,:) + f_il(:)
                displacement(itbf_il,:) = r_il(:)
            else
                tbforces(-itbf_il,:) = tbforces(-itbf_il,:) - f_il(:)
                displacement(-itbf_il,:) = -r_il(:)
            end if

            if (itbf_jk > 0) then
                tbforces(itbf_jk,:) = tbforces(itbf_jk,:) + f_jk(:)
                displacement(itbf_jk,:) = r_jk(:)
            else
                tbforces(-itbf_jk,:) = tbforces(-itbf_jk,:) - f_jk(:)
                displacement(-itbf_jk,:) = -r_jk(:)
            end if

            if (itbf_jl > 0) then
                tbforces(itbf_jl,:) = tbforces(itbf_jl,:) + f_jl(:)
                displacement(itbf_jl,:) = r_jl(:)
            else
                tbforces(-itbf_jl,:) = tbforces(-itbf_jl,:) - f_jl(:)
                displacement(-itbf_jl,:) = -r_jl(:)
            end if

            if (itbf_kl > 0) then
                tbforces(itbf_kl,:) = tbforces(itbf_kl,:) + f_kl(:)
                displacement(itbf_kl,:) = r_kl(:)
            else
                tbforces(-itbf_kl,:) = tbforces(-itbf_kl,:) - f_kl(:)
                displacement(-itbf_kl,:) = -r_kl(:)
            end if

            if (check) then
                print*, 'TB_CHECK: i, j, k, l=', iatm, jatm, katm, latm
                print*, 'TB_CHECK: f_i vs. f_ij + f_ik + f_il =>', &
                    & check_tbforce(f_i, f_ij+f_ik+f_il)
                print*, 'TB_CHECK:',f_i
                print*, 'TB_CHECK:',f_ij + f_ik + f_il
                print*, 'TB_CHECK: f_j vs. f_ji + f_jk + f_jl =>', & 
                    & check_tbforce(f_j, -f_ij+f_jk+f_jl)
                print*, 'TB_CHECK:',f_j
                print*, 'TB_CHECK:',- f_ij + f_jk + f_jl
                print*, 'TB_CHECK: f_k vs. f_ki + f_kj + f_kl =>', &
                    & check_tbforce(f_k, -f_ik-f_jk+f_kl)
                print*, 'TB_CHECK:',f_k
                print*, 'TB_CHECK:',- f_ik - f_jk + f_kl
                print*, 'TB_CHECK: f_l vs. f_li + f_lj + f_lk =>', &
                    & check_tbforce(f_l, -f_il-f_jl-f_kl)
                print*, 'TB_CHECK:',f_l
                print*, 'TB_CHECK:',- f_il - f_jl - f_kl
            end if

        enddo

    end subroutine

    subroutine print_tbforce()
        use total, only: bonded_pairs, nbonded
        use common_vars
        implicit none
        real(8) :: tbf_abs

        do itbf=1, nbonded
            iatm = bonded_pairs(itbf, 1)
            jatm = bonded_pairs(itbf, 2)

            tbf_abs = dot_product(tbforces(itbf,:), tbforces(itbf,:))
            if (-0.0001 < tbf_abs .and. tbf_abs < 0.0001) cycle
            write(*, '(2I5,3F15.7)'), iatm, jatm, tbforces(itbf_ij, :)
         end do
            
    end subroutine

    subroutine print_atom_order()
        use total, only: bonded_pairs
        use common_vars
        implicit none
        integer :: iatoms(3), jatoms(3), katoms(3), latoms(3)

        print*, '** print atom order for torsion **'
        ntorsion = size(force_consts)
        do itor=1, ntorsion
            iatm = four_atoms(itor,1)
            jatm = four_atoms(itor,2)
            katm = four_atoms(itor,3)
            latm = four_atoms(itor,4)

            itbf_ij = itor_to_itbf(itor, 1)
            if (itbf_ij > 0) then
                iatoms(1) = bonded_pairs(itbf_ij, 1)
                jatoms(1) = bonded_pairs(itbf_ij, 2)
            else
                iatoms(1) = bonded_pairs(-itbf_ij, 2)
                jatoms(1) = bonded_pairs(-itbf_ij, 1)
            end if

            itbf_ik = itor_to_itbf(itor, 2)
            if (itbf_ik > 0) then
                iatoms(2) = bonded_pairs(itbf_ik, 1)
                katoms(1) = bonded_pairs(itbf_ik, 2)
            else
                iatoms(2) = bonded_pairs(-itbf_ik, 2)
                katoms(1) = bonded_pairs(-itbf_ik, 1)
            end if

            itbf_il = itor_to_itbf(itor, 3)
            if (itbf_il > 0) then
                iatoms(3) = bonded_pairs(itbf_il, 1)
                latoms(1) = bonded_pairs(itbf_il, 2)
            else
                iatoms(3) = bonded_pairs(-itbf_il, 2)
                latoms(1) = bonded_pairs(-itbf_il, 1)
            end if

            itbf_jk = itor_to_itbf(itor, 4)
            if (itbf_jk > 0) then
                jatoms(2) = bonded_pairs(itbf_jk, 1)
                katoms(2) = bonded_pairs(itbf_jk, 2)
            else
                jatoms(2) = bonded_pairs(-itbf_jk, 2)
                katoms(2) = bonded_pairs(-itbf_jk, 1)
            end if

            itbf_jl = itor_to_itbf(itor, 5)
            if (itbf_jl > 0) then
                jatoms(3) = bonded_pairs(itbf_jl, 1)
                latoms(2) = bonded_pairs(itbf_jl, 2)
            else
                jatoms(3) = bonded_pairs(-itbf_jl, 2)
                latoms(2) = bonded_pairs(-itbf_jl, 1)
            end if

            itbf_kl = itor_to_itbf(itor, 6)
            if (itbf_kl > 0) then
                katoms(3) = bonded_pairs(itbf_kl, 1)
                latoms(3) = bonded_pairs(itbf_kl, 2)
            else
                katoms(3) = bonded_pairs(-itbf_kl, 2)
                latoms(3) = bonded_pairs(-itbf_kl, 1)
            end if

            print*, itor
            print*, iatm, iatoms
            print*, jatm, jatoms
            print*, katm, katoms
            print*, latm, latoms

         end do
            
    end subroutine

end module

!###############################################################################
module coulomb
    implicit none
    ! input
    real(8), allocatable :: charges(:) ! (natom)
    real(8) :: cutoff_length           ! cutoff length
    ! output
    real(8) :: energy                      ! enegry
    real(8), allocatable :: forces(:, :)   ! (natom, 3)
    real(8), allocatable :: tbforces(:, :) ! (max_tbf, 3)
    !(iatm_beg:iatm_end, iatm_beg:natom, 3)
    real(8), allocatable :: displacement(:, :) ! (ntbf, 3)

contains
    subroutine calculate(interact_table, ninteract)
        use total
        use common_vars
        implicit none
        integer, intent(in) :: ninteract
        integer, intent(in) :: interact_table(ninteract, 3)
                ! 1:iatm, 2:begin of jatm, 3:end of jatm
        real(8) :: coeff, cutoff_inv
        ! gained from PRESTO .  e^2 / (4 pi eps_0) [kcal/mol * A/eV^2]
        ! real(8), parameter :: coeff15 = 332.06378d0
        ! gained from Amebr difinition. ! e^2 / (4 pi eps_0) [kcal/mol * A/eV^2]
        real(8), parameter :: coeff15 = 332.05221729d0

        ! dielectric constant = 8.85418782... x 10^-12 [C^2/J M]

        ! for each nonbonded atom pairs,
        ! E_coulomb = 1/(4 pi eps_0)  q_i q_j / l_ij
        
        ! F_i = 1/(4 pi eps_0) q_i q_j / l_ij^3   r_ij
        ! F_j = - F_i

        ! F_ij = F_i
        ! F_ji = F_j

        ! initialization
        energy = 0.0d0
        forces = 0.0d0
        tbforces = 0.0d0
        displacement = 0.0d0

        coeff = coeff15
        cutoff_inv = 1.0d0/cutoff_length

        itbf = 0

        do jint=1, ninteract
            iatm     = interact_table(jint, 1)
            jatm_beg = interact_table(jint, 2)
            jatm_end = interact_table(jint, 3)

            do jatm=jatm_beg, jatm_end
                itbf = itbf + 1

                r_ij = crd(iatm, :) - crd(jatm, :)
                l_ij_inv = 1.0d0/sqrt( dot_product(r_ij, r_ij) )

                ! cutoff
                if (l_ij_inv < cutoff_inv) cycle

                ! calculate energy
                ! ene = coeff*charges(iatm)*charges(jatm) / l_ij
                ene = coeff*charges(iatm)*charges(jatm) * l_ij_inv
                energy = energy + ene

                ! calculate force
                ! f_i = ene * r_ij / (l_ij**2)
                f_i = ene * r_ij *l_ij_inv*l_ij_inv

                ! store force
                forces(iatm, :) = forces(iatm, :) + f_i(:)
                forces(jatm, :) = forces(jatm, :) - f_i(:)

                ! calculate and store two-body force and two-body distance vector
                f_ij = f_i
                tbforces(itbf, :) = f_ij(:)
                displacement(itbf, :) = r_ij(:)

                ! check
                if (check) then
                    print*, 'TB_CHECK: i, j =', iatm, jatm
                    print*, 'TB_CHECK: f_i vs. f_ij =>', check_tbforce(f_i, f_ij)
                    print*, 'TB_CHECK',f_i
                    print*, 'TB_CHECK',f_ij
                    print*, 'TB_CHECK: f_j vs. f_ji =>', check_tbforce(-f_i, -f_ij)
                    print*, 'TB_CHECK',-f_i
                    print*, 'TB_CHECK',-f_ij
                end if

            enddo

        enddo

    end subroutine

end module

module coulomb14
    implicit none
    ! input
    real(8), allocatable :: charges(:)     ! (natom)
    integer, allocatable :: i14_to_itbf(:) ! (n14)
    ! output
    real(8) :: energy                      ! enegry
    real(8), allocatable :: forces(:, :)   ! (natom, 3)
    real(8), allocatable :: tbforces(:, :) ! (ntbf, 3)
    real(8), allocatable :: displacement(:, :)! (ntbf, 3)

    ! parameter
    real(8) :: scale_factor = 1.2d0    ! scaling factor for 1-4 interaction
    
    ! main variales
    integer :: i14, n14, itbf_ij
    integer :: iatm, jatm

contains
    subroutine calculate()
        use total
        use common_vars
        implicit none
        real(8) :: coeff
        ! gained from PRESTO .  e^2 / (4 pi eps_0) [kcal/mol * A/eV^2]
        ! real(8), parameter :: coeff15 = 332.06378d0
        ! gained from Amebr difinition. ! e^2 / (4 pi eps_0) [kcal/mol * A/eV^2]
        real(8), parameter :: coeff15 = 332.05221729d0
        ! dielectric constant = 8.85418782... x 10^-12 [C^2/J M]

        ! for each nonbonded atom pairs,
        ! E_coulomb = 1/(4 pi eps_0)  q_i q_j / l_ij
        
        ! F_i = 1/(4 pi eps_0) q_i q_j / l_ij^3   r_ij
        ! F_j = - F_i

        ! F_ij = F_i
        ! F_ji = F_j

        ! initialization
        energy = 0.0d0
        forces = 0.0d0
        tbforces = 0.0d0
        displacement = 0.0d0

        coeff = coeff15/scale_factor
        n14   = size(i14_to_itbf)

        do i14=1, n14
            itbf_ij = i14_to_itbf(i14)
            iatm = bonded_pairs(abs(itbf_ij), 1)
            jatm = bonded_pairs(abs(itbf_ij), 2)

            r_ij = crd(iatm, :) - crd(jatm, :)
            l_ij = sqrt( dot_product(r_ij, r_ij) )

            ! calculate energy
            ene = coeff*charges(iatm)*charges(jatm) / l_ij
            energy = energy + ene

            ! calculate force
            f_i = ene * r_ij / (l_ij**2)

            ! store force
            forces(iatm, :) = forces(iatm, :) + f_i(:)
            forces(jatm, :) = forces(jatm, :) - f_i(:)

            ! calculate two-body force
            f_ij = f_i

            ! store two-body force and two-body distance vector
            if (itbf_ij > 0) then
                tbforces(itbf_ij,:) = tbforces(itbf_ij,:) + f_ij(:)
                displacement(itbf_ij,:) = r_ij(:)
            else
                tbforces(-itbf_ij,:) = tbforces(-itbf_ij,:) - f_ij(:)
                displacement(-itbf_ij,:) = -r_ij(:)
            end if

            ! check
            if (check) then
                print*, 'TB_CHECK: i, j =', iatm, jatm
                print*, 'TB_CHECK: f_i vs. f_ij =>', check_tbforce(f_i, f_ij)
                print*, 'TB_CHECK',f_i
                print*, 'TB_CHECK',f_ij
                print*, 'TB_CHECK: f_j vs. f_ji =>', check_tbforce(-f_i, -f_ij)
                print*, 'TB_CHECK',-f_i
                print*, 'TB_CHECK',-f_ij
            end if

        enddo

        ! print*, 'c14'
        ! do iatm=1, natom
            ! print*, iatm, forces(iatm,:)
        ! end do
        
    end subroutine

    subroutine print_tbforce()
        use total, only: bonded_pairs, nbonded
        use common_vars
        implicit none
        real(8) :: tbf_abs

        do itbf=1, nbonded
            iatm = bonded_pairs(itbf, 1)
            jatm = bonded_pairs(itbf, 2)

            tbf_abs = dot_product(tbforces(itbf,:), tbforces(itbf,:))
            if (-0.0001 < tbf_abs .and. tbf_abs < 0.0001) cycle
            write(*, '(2I5,3F15.7)'), iatm, jatm, tbforces(itbf_ij, :)
         end do
            
    end subroutine

end module

!###############################################################################
module vdw
    implicit none
    ! input
    ! integer, allocatable :: interact_table(:,:) ! (nint, 3)
    !         ! 1:iatm, 2:begin of jatm, 3:end of jatm
    integer, allocatable :: atom_types(:)  ! (natom)
    real(8), allocatable :: c6s(:,:)       ! (num_atomtypes, num_atomtypes)
    real(8), allocatable :: c12s(:,:)      ! (num_atomtypes, num_atomtypes)
    real(8) :: cutoff_length               ! cutoff length
    ! output
    real(8) :: energy
    real(8), allocatable :: forces(:, :)   ! (natom, 3)
    real(8), allocatable :: tbforces(:, :) ! (max_tbf, 3)
    !(iatm_beg:iatm_end, iatm_beg:natom, 3)
    real(8), allocatable :: displacement(:, :)! (ntbf, 3)

contains
    subroutine calculate(interact_table, ninteract)
        use total
        use common_vars
        implicit none
        integer, intent(in) :: ninteract
        integer, intent(in) :: interact_table(ninteract, 3)
                ! 1:iatm, 2:begin of jatm, 3:end of jatm
        real(8) :: c6, c12, cutoff_len2, coeff
        real(8) :: l_ij2
        real(8), parameter :: coeff15 = 1.0

        ! for each nonbonded atom pairs,
        ! E_vdw = eps_ij ( A_ij/l_ij^12 - B_ij/l_ij^6)
        !       = C12/l_ij^12 - C6/l_ij^6
        
        ! F_i = (-12*C12/l_ij^13 + 6*C6/l_ij^7 ) r_ij/l_ij
        ! F_j = - F_i

        ! F_ij = F_i
        ! F_ji = F_j

        ! initialization
        energy = 0.0d0
        forces = 0.0d0
        tbforces = 0.0d0
        displacement = 0.0d0
        cutoff_len2 = cutoff_length * cutoff_length
        coeff = coeff15

        itbf = 0
        do jint=1, ninteract
            iatm     = interact_table(jint, 1)
            jatm_beg = interact_table(jint, 2)
            jatm_end = interact_table(jint, 3)

            do jatm=jatm_beg, jatm_end
                itbf = itbf + 1

                r_ij = crd(iatm, :) - crd(jatm, :)
                l_ij2 = dot_product(r_ij, r_ij)

                ! cutoff
                if (l_ij2 > cutoff_len2) cycle

                c6   = c6s( atom_types(iatm), atom_types(jatm) )
                c12  = c12s( atom_types(iatm), atom_types(jatm) )

                ! calculate energy
                ene = coeff*(c12/l_ij2**6 - c6/l_ij2**3)
                energy = energy + ene

                ! calculate force
                f_i = - coeff*(-12.0d0*c12/l_ij2**7 + 6.0d0*c6/l_ij2**4 ) * r_ij

                ! store force
                forces(iatm, :) = forces(iatm, :) + f_i(:)
                forces(jatm, :) = forces(jatm, :) - f_i(:)

                ! calculate and store two-body force and two-body distance vector
                f_ij = f_i
                tbforces(itbf, :) = f_ij(:)
                displacement(itbf, :) = r_ij(:)

                ! check
                if (check) then
                    print*, 'TB_CHECK: i, j =', iatm, jatm
                    print*, 'TB_CHECK: f_i vs. f_ij =>', check_tbforce(f_i, f_ij)
                    print*, 'TB_CHECK',f_i
                    print*, 'TB_CHECK',f_ij
                    print*, 'TB_CHECK: f_j vs. f_ji =>', check_tbforce(-f_i, -f_ij)
                    print*, 'TB_CHECK',-f_i
                    print*, 'TB_CHECK',-f_ij
                end if

            enddo

        enddo

    end subroutine

end module


!###############################################################################
module vdw14
    implicit none
    ! input
    integer, allocatable :: atom_types(:)  ! (natom)
    real(8), allocatable :: c6s(:,:)       ! (num_atomtypes, num_atomtypes)
    real(8), allocatable :: c12s(:,:)      ! (num_atomtypes, num_atomtypes)
    integer, allocatable :: i14_to_itbf(:) ! (n14)
    ! output
    real(8) :: energy
    real(8), allocatable :: forces(:, :)   ! (natom, 3)
    real(8), allocatable :: tbforces(:, :) ! (ntbf, 3)
    real(8), allocatable :: displacement(:, :)! (ntbf, 3)

    ! parameter
    real(8) :: scale_factor = 2.0d0 ! scaling factor for 1-4 interaction

    ! main variales
    integer :: i14, n14, itbf_ij
    integer :: iatm, jatm

contains
    subroutine calculate()
        use total
        use common_vars
        implicit none
        real(8) :: c6, c12, l_ij2, coeff
        real(8), parameter :: coeff15 = 1.0

        ! for each nonbonded atom pairs,
        ! E_vdw = eps_ij ( A_ij/l_ij^12 - B_ij/l_ij^6)
        !       = C12/l_ij^12 - C6/l_ij^6
        
        ! F_i = (-12*C12/l_ij^13 + 6*C6/l_ij^7 ) r_ij/l_ij
        ! F_j = - F_i

        ! F_ij = F_i
        ! F_ji = F_j

        ! initialization
        energy = 0.0d0
        forces = 0.0d0
        tbforces = 0.0d0
        displacement = 0.0d0

        coeff = coeff15/scale_factor
        n14 = size(i14_to_itbf)

        do i14=1, n14
            itbf_ij = i14_to_itbf(i14)
            iatm = bonded_pairs(abs(itbf_ij), 1)
            jatm = bonded_pairs(abs(itbf_ij), 2)

            r_ij = crd(iatm, :) - crd(jatm, :)
            l_ij2 = dot_product(r_ij, r_ij)

            c6   = c6s( atom_types(iatm), atom_types(jatm) )
            c12  = c12s( atom_types(iatm), atom_types(jatm) )

            ! calculate energy
            ene = coeff*(c12/l_ij2**6 - c6/l_ij2**3)
            energy = energy + ene

            ! calculate force
            f_i =  - coeff*(- 12.0d0*c12/l_ij2**7 + 6.0d0*c6/l_ij2**4 ) * r_ij

            ! store force
            forces(iatm, :) = forces(iatm, :) + f_i(:)
            forces(jatm, :) = forces(jatm, :) - f_i(:)

            ! calculate two-body force
            f_ij = f_i

            ! store two-body force and two-body distance vector
            if (itbf_ij > 0) then
                tbforces(itbf_ij,:) = tbforces(itbf_ij,:) + f_ij(:)
                displacement(itbf_ij,:) = r_ij(:)
            else
                tbforces(-itbf_ij,:) = tbforces(-itbf_ij,:) - f_ij(:)
                displacement(-itbf_ij,:) = -r_ij(:)
            end if

            ! check
            if (check) then
                print*, 'TB_CHECK: i, j =', iatm, jatm
                print*, 'TB_CHECK: f_i vs. f_ij =>', check_tbforce(f_i, f_ij)
                print*, 'TB_CHECK',f_i
                print*, 'TB_CHECK',f_ij
                print*, 'TB_CHECK: f_j vs. f_ji =>', check_tbforce(-f_i, -f_ij)
                print*, 'TB_CHECK',-f_i
                print*, 'TB_CHECK',-f_ij
            end if

        enddo

    end subroutine

    subroutine print_tbforce()
        use total, only: bonded_pairs, nbonded
        use common_vars
        implicit none
        real(8) :: tbf_abs

        do itbf=1, nbonded
            iatm = bonded_pairs(itbf, 1)
            jatm = bonded_pairs(itbf, 2)

            tbf_abs = dot_product(tbforces(itbf,:), tbforces(itbf,:))
            if (-0.0001 < tbf_abs .and. tbf_abs < 0.0001) cycle
            write(*, '(2I5,3F15.7)'), iatm, jatm, tbforces(itbf_ij, :)
         end do
            
    end subroutine

end module

! subroutine cal_distance_restraint()
! end

!###############################################################################
subroutine setup(natom, check, bonded_pairs, nbonded, max_tbf)
    ! call at the beginning of the all snap shots.
    use total, &
            & t_natom             => natom           ,  & 
            & t_crd               => crd             ,  & 
            & t_nbonded           => nbonded         ,  & 
            & t_bonded_pairs      => bonded_pairs    ,  & 
            & t_bonded_tbforces   => bonded_tbforces ,  & 
            & t_check             => check


    use common_vars
    use bond      , bnd_forces => forces, bnd_tbforces => tbforces, bnd_disp => displacement
    use angle     , ang_forces => forces, ang_tbforces => tbforces, ang_disp => displacement
    use torsion   , tor_forces => forces, tor_tbforces => tbforces, tor_disp => displacement
    use improper  , imp_forces => forces, imp_tbforces => tbforces, imp_disp => displacement
    use coulomb   , cou_forces => forces, cou_tbforces => tbforces, cou_disp => displacement
    use vdw       , vdw_forces => forces, vdw_tbforces => tbforces, vdw_disp => displacement
    use coulomb14 , cou14_forces => forces, cou14_tbforces => tbforces, cou14_disp => displacement
    use vdw14     , vdw14_forces => forces, vdw14_tbforces => tbforces, vdw14_disp => displacement

    implicit none
    integer, intent(in) :: natom
    integer, intent(in) :: nbonded
    integer, intent(in) :: max_tbf
    logical, intent(in) :: check
    integer, intent(in) :: bonded_pairs(nbonded, 2)

    ! allocate
    t_natom = natom
    t_check = check
    t_nbonded = size(bonded_pairs, 1)
    allocate(t_crd(t_natom, 3))
    allocate(t_bonded_pairs(t_nbonded, 2))
    allocate(t_bonded_tbforces(t_nbonded, 3))
    t_bonded_pairs   = bonded_pairs

    ! allocate each force
    allocate(bnd_forces(t_natom, 3))
    allocate(ang_forces(t_natom, 3))
    allocate(tor_forces(t_natom, 3))
    allocate(imp_forces(t_natom, 3))
    allocate(cou_forces(t_natom, 3))
    allocate(vdw_forces(t_natom, 3))
    allocate(cou14_forces(t_natom, 3))
    allocate(vdw14_forces(t_natom, 3))

    ! allocate each two-body force for bonded
    allocate(bnd_tbforces(t_nbonded, 3))
    allocate(ang_tbforces(t_nbonded, 3))
    allocate(tor_tbforces(t_nbonded, 3))
    allocate(imp_tbforces(t_nbonded, 3))
    allocate(cou14_tbforces(t_nbonded, 3))
    allocate(vdw14_tbforces(t_nbonded, 3))

    ! allocate each two-body force for nonbonded
    allocate(cou_tbforces(max_tbf, 3))
    allocate(vdw_tbforces(max_tbf, 3))

    ! allocate each two-body distance (crd_i - crd_j) matrix
    allocate(bnd_disp(t_nbonded, 3))
    allocate(ang_disp(t_nbonded, 3))
    allocate(tor_disp(t_nbonded, 3))
    allocate(imp_disp(t_nbonded, 3))
    allocate(cou_disp(max_tbf, 3))
    allocate(vdw_disp(max_tbf, 3))
    allocate(cou14_disp(t_nbonded, 3))
    allocate(vdw14_disp(t_nbonded, 3))

end subroutine

subroutine initialize(crd, natom)
    ! call each the snapshot
    use total, &
         & t_natom             => natom             , &
         & t_crd               => crd               , & 
         & t_bonded_tbforces   => bonded_tbforces
    implicit none
    integer, intent(in) :: natom
    real(8), intent(in) :: crd(natom, 3)

    t_crd = crd
    t_bonded_tbforces = 0.0d0

end subroutine

! subroutine get_bonded_tbforce()
    ! use total, &
          ! & t_natom             => natom             ,  & 
          ! & t_nbonded      => nbonded      ,  & 
          ! & t_bonded_pairs => bonded_pairs ,  & 
          ! & t_bonded_tbforces   => bonded_tbforces
    ! use bond      , bnd_tbforces => tbforces
    ! use angle     , ang_tbforces => tbforces
    ! use torsion   , tor_tbforces => tbforces
    ! use improper  , imp_tbforces => tbforces
    ! use common_vars
    ! implicit none
    ! real(8) :: total_tbforces(nbonded, 3)

    ! ! allocate(total_tbforces(t_natom, t_nextent, 3))
    ! total_tbforces = bnd_tbforces + ang_tbforces + tor_tbforces + imp_tbforces

! end subroutine

subroutine sink_nohyd(solv_crd, natom_solv, base_crd, shell_crd, &
    & probe_length, natom_base, natom_shell)

    implicit none

    ! arguments variables
    integer, intent(in) :: natom_base, natom_shell
    real(8), intent(in) :: probe_length
    real(8), intent(in) :: base_crd(natom_base, 3)
    real(8), intent(in) :: shell_crd(natom_shell, 3)

    ! return variables
    integer, intent(out):: natom_solv
    real(8), intent(out):: solv_crd(natom_shell+100, 3)

    ! internal variables
    logical :: remove_list(natom_shell)
    real(8) :: r_ij(3), l_ij2, lcut2
    integer :: iatm, jatm


    ! initialization
    solv_crd = 0.0
    remove_list = .false. 
    lcut2 = probe_length*probe_length

    ! pick up the water atoms to be removed by the probe probe length
    do iatm=1, natom_shell

        do jatm=1, natom_base

            r_ij(:) = shell_crd(iatm,:) - base_crd(jatm,:)
            l_ij2 = r_ij(1)**2 + r_ij(2)**2 + r_ij(3)**2

            if ( l_ij2 < lcut2 ) then
                remove_list(iatm) = .true.
                exit
            end if

        end do

    enddo

    ! make new coordinate for solvation
    do iatm=1, natom_base
        solv_crd(iatm, :) = base_crd(iatm, :)
    end do

    iatm = 0
    do jatm=1, natom_shell
        if ( remove_list(jatm) ) cycle

        iatm = iatm + 1
        solv_crd(natom_base+iatm, :) = shell_crd(jatm, :)

    end do

    natom_solv = natom_base + iatm

end subroutine

subroutine sink(solv_crd, natom_solv, base_crd, shell_crd, &
    & probe_length, natom_base, natom_shell)

    implicit none

    ! arguments variables
    integer, intent(in) :: natom_base, natom_shell
    real(8), intent(in) :: probe_length
    real(8), intent(in) :: base_crd(natom_base, 3)
    real(8), intent(in) :: shell_crd(natom_shell, 3)

    ! return variables
    integer, intent(out):: natom_solv
    real(8), intent(out):: solv_crd(natom_shell+100, 3)

    ! internal variables
    logical :: remove_list(natom_shell)
    real(8) :: r_ij(3), l_ij2, lcut2
    integer :: iatm, jatm, ires_1


    ! initialization
    solv_crd = 0.0
    remove_list = .false. 
    lcut2 = probe_length*probe_length

    ! pick up the water atoms to be removed by the probe probe length

    do iatm=1, natom_shell

        do jatm=1, natom_base

            r_ij(:) = shell_crd(iatm,:) - base_crd(jatm,:)
            l_ij2 = r_ij(1)**2 + r_ij(2)**2 + r_ij(3)**2

            if ( l_ij2 < lcut2 ) then
                ires_1 = (iatm-1) / 3

                remove_list(3*(ires_1)+1) = .true.
                remove_list(3*(ires_1)+2) = .true.
                remove_list(3*(ires_1)+3) = .true.
                exit
            end if

        end do

    enddo

    ! make new coordinate for solvation
    do iatm=1, natom_base
        solv_crd(iatm, :) = base_crd(iatm, :)
    end do

    iatm = 0
    do jatm=1, natom_shell
        if ( remove_list(jatm) ) cycle

        iatm = iatm + 1
        solv_crd(natom_base+iatm, :) = shell_crd(jatm, :)

    end do

    natom_solv = natom_base + iatm

end subroutine

subroutine calvolume_org(radii, volumes, crd, well2s, natom)
    implicit none
    integer, intent(in) :: natom
    real(8), intent(in) :: crd(natom, 3), well2s(natom)
    real(8), intent(out):: radii(natom), volumes(natom)

    real(8), parameter :: PI = 3.141592653589793
    integer :: iatm, jatm
    real(8) :: r_ij(3), l_ij, l_ij2, well2, num, den, nearest_l_ij2

    ! initialization
    radii = 0.0d0
    volumes = 0.0d0

    ! calculate radius and volume
    do iatm=1, natom
        well2 = well2s(iatm)
        num = 0.0d0 ! numerator
        den = 0.0d0 ! denominator

        ! judge
        nearest_l_ij2 = 100.0d0

        do jatm=1, natom
            if (iatm == jatm) cycle
            r_ij  = crd(iatm,:) - crd(jatm,:)
            l_ij2 = dot_product(r_ij, r_ij)
            if (l_ij2 < nearest_l_ij2) nearest_l_ij2 = l_ij2

            if (l_ij2 > well2) cycle

            l_ij = sqrt(l_ij2)

            num = num + 1.0d0/l_ij
            den = den + 1.0d0/l_ij2
        enddo

        if (nearest_l_ij2 <= well2) then
            radii(iatm) = 0.5d0 * num / den
        else
            radii(iatm) = 0.5d0 * sqrt(nearest_l_ij2)
        end if

    enddo

    volumes = 4.0d0 * PI * radii**3 / 3.0d0

end subroutine

! the volume of atom that include all atoms
subroutine calvolume(radii, volumes, crd, well2s, natom)
    implicit none
    integer, intent(in) :: natom
    real(8), intent(in) :: crd(natom, 3), well2s(natom)
    real(8), intent(out):: radii(natom), volumes(natom)

    real(8), parameter :: PI = 3.141592653589793
    integer :: iatm, jatm
    real(8) :: r_ij(3), l_ij, l_ij2, well2, num, den, nearest_l_ij2

    ! initialization
    radii = 0.0d0
    volumes = 0.0d0

    ! calculate radius and volume
    do iatm=1, natom
        well2 = well2s(iatm)
        num = 0.0d0 ! numerator
        den = 0.0d0 ! denominator

        ! judge
        nearest_l_ij2 = 100.0d0

        do jatm=1, natom
            if (iatm == jatm) cycle
            r_ij  = crd(iatm,:) - crd(jatm,:)
            l_ij2 = dot_product(r_ij, r_ij)
            if (l_ij2 < nearest_l_ij2) nearest_l_ij2 = l_ij2

            ! if (l_ij2 > well2) cycle

            l_ij = sqrt(l_ij2)

            num = num + 1.0d0/l_ij
            den = den + 1.0d0/l_ij2
        enddo

        radii(iatm) = 0.5d0 * num / den

    enddo

    volumes = 4.0d0 * PI * radii**3 / 3.0d0

end subroutine

module io_manager
    implicit none
    integer :: iounit_int = 10

contains

     integer function io_unit()
        implicit none

        iounit_int = iounit_int + 1
        io_unit = iounit_int
        
    end function
    
end module

!###############################################################################
module unformatted_velocity
    implicit none
    integer :: fileno

contains
    subroutine initialize(filename)
        use io_manager
        implicit none
        character(*), intent(in) :: filename
        integer :: ierr

        fileno = io_unit()

        open(fileno, file=filename, status='old', form='unformatted', & 
            & iostat=ierr)

        ! check
        if (ierr/= 0) then
            write(*,*) 'Could not create a file: ', filename
            stop
        end if

    end subroutine

    subroutine finalize()
        implicit none
        close(fileno)
    end subroutine

    subroutine parse_next(natom, vel)
        implicit none
        integer, intent(in) :: natom
        real(8), intent(out):: vel(natom, 3)
        integer :: iloop
        real(8) :: simtime, cputime, energy, kinetic, temperature, potential, rmsf
        integer :: num_vdw_pair, num_hydrogen_pair
        real(8) :: rmsd

        read(fileno) iloop, simtime, cputime, &
            & energy, kinetic, temperature, potential, rmsf, &
            & num_vdw_pair, num_hydrogen_pair, rmsd

        read(fileno) vel
        
    end subroutine

end module

!###############################################################################
module unformatted_coordinate
    implicit none
    integer :: fileno

contains
    subroutine initialize(filename)
        use io_manager
        implicit none
        character(*), intent(in) :: filename
        integer :: ierr

        fileno = io_unit()

        open(fileno, file=filename, status='old', form='unformatted', & 
            & iostat=ierr)

        ! check
        if (ierr/= 0) then
            write(*,*) 'Could not create a file: ', filename
            stop
        end if

    end subroutine

    subroutine finalize()
        implicit none
        close(fileno)
    end subroutine

    subroutine parse_next(natom, crd)
        implicit none
        integer, intent(in) :: natom
        real(8), intent(out):: crd(natom, 3)
        integer :: iloop
        real(8) :: simtime, cputime, energy, kinetic, temperature, potential, rmsf
        integer :: num_vdw_pair, num_hydrogen_pair
        real(8) :: rmsd

        read(fileno) iloop, simtime, cputime, &
            & energy, kinetic, temperature, potential, rmsf, &
            & num_vdw_pair, num_hydrogen_pair, rmsd

        read(fileno) crd
        
    end subroutine

end module

!###############################################################################
module unformatted_restart
    implicit none
    integer :: fileno

contains
    subroutine initialize(filename)
        use io_manager
        implicit none
        character(*), intent(in) :: filename
        integer :: ierr

        fileno = io_unit()

        open(fileno, file=filename, status='old', form='unformatted', & 
            & iostat=ierr)

        ! check
        if (ierr/= 0) then
            write(*,*) 'Could not create a file: ', filename
            stop
        end if

    end subroutine

    subroutine finalize()
        implicit none
        close(fileno)
    end subroutine

    subroutine parse1(title, iloop, simtime, energy, kinetic, potential, ierr)
        implicit none
        character(*), intent(out) :: title
        integer, intent(out) :: iloop
        real(8), intent(out) :: simtime, energy, kinetic, potential
        integer, intent(out) :: ierr

        integer :: num_atom, num_var

        read(fileno, iostat=ierr) title
        read(fileno, iostat=ierr) num_atom, num_var
        read(fileno, iostat=ierr) iloop, simtime, energy, kinetic, potential

        ! if (ierr/= 0) then
        !     write(*,*) 'Could not create a file: ', filename
        !     stop
        ! end if

    end subroutine

    subroutine parse_crd(natom, crd, ierr)
        implicit none
        ! real(8), allocatable, intent(out):: crd(:,:)
        integer, intent(in) :: natom
        real(8), intent(out):: crd(natom,3)
        integer, intent(out):: ierr

        read(fileno, iostat=ierr) crd

    end subroutine

    subroutine parse_vel(natom, vel, ierr)
        implicit none
        integer, intent(in) :: natom
        real(8), intent(out):: vel(natom,3)
        integer, intent(out):: ierr

        read(fileno, iostat=ierr) vel
    end subroutine

end module


! subroutine parse_restart()
! end subroutine

module pickup

    implicit none
    integer, allocatable :: res_beg_end_pairs(:, :) ! (nres, 2)
    real(8) :: cutoff2
    integer :: cutoff_method ! 1: com, 2: nearest, 3: farthest

contains

    subroutine get_candidate_pairs(candidate, crd, nres, natom)
        
        implicit none

        integer, intent(in) :: natom, nres
        real(8), intent(in) :: crd(natom, 3)
        logical, intent(out):: candidate(nres, nres)

        integer :: ires, jres, ibeg, iend, jbeg, jend


        candidate = .false.

        do ires=1, nres-1
            ibeg = res_beg_end_pairs(ires, 1)
            iend = res_beg_end_pairs(ires, 2)

            do jres=ires+1, nres
                jbeg = res_beg_end_pairs(jres, 1)
                jend = res_beg_end_pairs(jres, 2)

                if (cutoff_method == 1) then
                    if ( is_com(crd(ibeg:iend,:), crd(jbeg:jend,:)) ) then
                        candidate(ires, jres) = .true.
                    end if
                else if (cutoff_method == 2) then
                    if ( is_nearest(crd(ibeg:iend,:), crd(jbeg:jend,:)) ) then
                        candidate(ires, jres) = .true.
                    end if
                else if (cutoff_method == 3) then
                    if ( is_farthest(crd(ibeg:iend,:), crd(jbeg:jend,:)) ) then
                        candidate(ires, jres) = .true.
                    end if
                end if

            end do

        end do

    end subroutine

    logical function is_com(crd_i, crd_j)

        implicit none
        real(8), intent(in) :: crd_i(:,:), crd_j(:,:)

        real(8) :: rcom_ij(3)

        rcom_ij(:) = sum(crd_i,1)/size(crd_i,1) - sum(crd_j,1)/size(crd_j,1)
        is_com =  dot_product(rcom_ij, rcom_ij) <= cutoff2

    end function

    logical function is_nearest(crd_i, crd_j)

        implicit none
        real(8), intent(in) :: crd_i(:,:), crd_j(:,:)

        integer :: iatm, jatm
        real(8) :: r_ij(3)

        is_nearest = .false.
        do iatm=1, size(crd_i, 1)
            do jatm=1, size(crd_j, 1)

                r_ij(:) = crd_i(iatm,:) - crd_j(jatm,:)
                if (dot_product(r_ij, r_ij) <= cutoff2) then
                    is_nearest = .true.
                    exit
                end if

            end do
            if (is_nearest) exit

        end do

    end function

    logical function is_farthest(crd_i, crd_j)

        implicit none
        real(8), intent(in) :: crd_i(:,:), crd_j(:,:)

        integer :: iatm, jatm
        real(8) :: r_ij(3)

        is_farthest = .true.
        do iatm=1, ubound(crd_i, 1)
            do jatm=1, ubound(crd_j, 1)

                r_ij(:) = crd_i(iatm,:) - crd_j(jatm,:)
                if (dot_product(r_ij, r_ij) >= cutoff2) then
                    is_farthest = .false.
                    exit
                end if

            end do
            if (.not.is_farthest) exit

        end do

    end function 

end module


subroutine is_com(ok, crd_i, crd_j, cutoff2, natom_i, natom_j)

    implicit none
    integer, intent(in) :: natom_i, natom_j
    real(8), intent(in) :: crd_i(natom_i,3), crd_j(natom_j,3), cutoff2
    logical, intent(out):: ok

    real(8) :: rcom_ij(3)

    rcom_ij(:) = sum(crd_i,1)/size(crd_i,1) - sum(crd_j,1)/size(crd_j,1)
    ok =  dot_product(rcom_ij, rcom_ij) <= cutoff2

end subroutine 

subroutine is_nearest(ok, crd_i, crd_j, cutoff2, natom_i, natom_j)

    implicit none
    integer, intent(in) :: natom_i, natom_j
    real(8), intent(in) :: crd_i(natom_i,3), crd_j(natom_j,3), cutoff2
    logical, intent(out):: ok

    integer :: iatm, jatm
    real(8) :: r_ij(3)

    ok = .false.
    do iatm=1, natom_i
        do jatm=1, natom_j

            r_ij(:) = crd_i(iatm,:) - crd_j(jatm,:)
            if (dot_product(r_ij, r_ij) <= cutoff2) then
                ok = .true.
                exit
            end if

        end do
        if (ok) exit

    end do

end subroutine 

subroutine is_farthest(ok, crd_i, crd_j, cutoff2, natom_i, natom_j)

    implicit none
    integer, intent(in) :: natom_i, natom_j
    real(8), intent(in) :: crd_i(natom_i,3), crd_j(natom_j,3), cutoff2
    logical, intent(out):: ok

    integer :: iatm, jatm
    real(8) :: r_ij(3)

    ok = .true.
    do iatm=1, natom_i
        do jatm=1, natom_j

            r_ij(:) = crd_i(iatm,:) - crd_j(jatm,:)
            if (dot_product(r_ij, r_ij) >= cutoff2) then
                ok = .false.
                exit
            end if

        end do
        if (.not.ok) exit

    end do

end subroutine 
